"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.setA11yOption = exports.setA11yOptions = exports.ExplorerHandler = exports.ExplorerMathDocumentMixin = exports.ExplorerMathItemMixin = void 0;
const MathItem_js_1 = require("../core/MathItem.js");
const semantic_enrich_js_1 = require("./semantic-enrich.js");
const Options_js_1 = require("../util/Options.js");
const SerializedMmlVisitor_js_1 = require("../core/MmlTree/SerializedMmlVisitor.js");
const MJContextMenu_js_1 = require("../ui/menu/MJContextMenu.js");
const ke = __importStar(require("./explorer/KeyExplorer.js"));
const me = __importStar(require("./explorer/MouseExplorer.js"));
const TreeExplorer_js_1 = require("./explorer/TreeExplorer.js");
const Region_js_1 = require("./explorer/Region.js");
const sre_js_1 = __importDefault(require("./sre.js"));
(0, MathItem_js_1.newState)('EXPLORER', 160);
function ExplorerMathItemMixin(BaseMathItem, toMathML) {
    return class extends BaseMathItem {
        constructor() {
            super(...arguments);
            this.explorers = {};
            this.attached = [];
            this.restart = [];
            this.refocus = false;
            this.savedId = null;
        }
        explorable(document, force = false) {
            if (this.state() >= MathItem_js_1.STATE.EXPLORER)
                return;
            if (!this.isEscaped && (document.options.enableExplorer || force)) {
                const node = this.typesetRoot;
                const mml = toMathML(this.root);
                if (this.savedId) {
                    this.typesetRoot.setAttribute('sre-explorer-id', this.savedId);
                    this.savedId = null;
                }
                this.explorers = initExplorers(document, node, mml);
                this.attachExplorers(document);
            }
            this.state(MathItem_js_1.STATE.EXPLORER);
        }
        attachExplorers(document) {
            this.attached = [];
            let keyExplorers = [];
            for (let key of Object.keys(this.explorers)) {
                let explorer = this.explorers[key];
                if (explorer instanceof ke.AbstractKeyExplorer) {
                    explorer.AddEvents();
                    explorer.stoppable = false;
                    keyExplorers.unshift(explorer);
                }
                if (document.options.a11y[key]) {
                    explorer.Attach();
                    this.attached.push(key);
                }
                else {
                    explorer.Detach();
                }
            }
            for (let explorer of keyExplorers) {
                if (explorer.attached) {
                    explorer.stoppable = true;
                    break;
                }
            }
        }
        rerender(document, start = MathItem_js_1.STATE.RERENDER) {
            this.savedId = this.typesetRoot.getAttribute('sre-explorer-id');
            this.refocus = (window.document.activeElement === this.typesetRoot);
            for (let key of this.attached) {
                let explorer = this.explorers[key];
                if (explorer.active) {
                    this.restart.push(key);
                    explorer.Stop();
                }
            }
            super.rerender(document, start);
        }
        updateDocument(document) {
            super.updateDocument(document);
            this.refocus && this.typesetRoot.focus();
            this.restart.forEach(x => this.explorers[x].Start());
            this.restart = [];
            this.refocus = false;
        }
    };
}
exports.ExplorerMathItemMixin = ExplorerMathItemMixin;
function ExplorerMathDocumentMixin(BaseDocument) {
    var _a;
    return _a = class extends BaseDocument {
            constructor(...args) {
                super(...args);
                const ProcessBits = this.constructor.ProcessBits;
                if (!ProcessBits.has('explorer')) {
                    ProcessBits.allocate('explorer');
                }
                const visitor = new SerializedMmlVisitor_js_1.SerializedMmlVisitor(this.mmlFactory);
                const toMathML = ((node) => visitor.visitTree(node));
                this.options.MathItem = ExplorerMathItemMixin(this.options.MathItem, toMathML);
                this.explorerRegions = initExplorerRegions(this);
            }
            explorable() {
                if (!this.processed.isSet('explorer')) {
                    if (this.options.enableExplorer) {
                        for (const math of this.math) {
                            math.explorable(this);
                        }
                    }
                    this.processed.set('explorer');
                }
                return this;
            }
            state(state, restore = false) {
                super.state(state, restore);
                if (state < MathItem_js_1.STATE.EXPLORER) {
                    this.processed.clear('explorer');
                }
                return this;
            }
        },
        _a.OPTIONS = Object.assign(Object.assign({}, BaseDocument.OPTIONS), { enableExplorer: true, renderActions: (0, Options_js_1.expandable)(Object.assign(Object.assign({}, BaseDocument.OPTIONS.renderActions), { explorable: [MathItem_js_1.STATE.EXPLORER] })), sre: (0, Options_js_1.expandable)(Object.assign(Object.assign({}, BaseDocument.OPTIONS.sre), { speech: 'shallow' })), a11y: {
                align: 'top',
                backgroundColor: 'Blue',
                backgroundOpacity: 20,
                braille: false,
                flame: false,
                foregroundColor: 'Black',
                foregroundOpacity: 100,
                highlight: 'None',
                hover: false,
                infoPrefix: false,
                infoRole: false,
                infoType: false,
                keyMagnifier: false,
                magnification: 'None',
                magnify: '400%',
                mouseMagnifier: false,
                speech: true,
                subtitles: true,
                treeColoring: false,
                viewBraille: false
            } }),
        _a;
}
exports.ExplorerMathDocumentMixin = ExplorerMathDocumentMixin;
function ExplorerHandler(handler, MmlJax = null) {
    if (!handler.documentClass.prototype.enrich && MmlJax) {
        handler = (0, semantic_enrich_js_1.EnrichHandler)(handler, MmlJax);
    }
    handler.documentClass = ExplorerMathDocumentMixin(handler.documentClass);
    return handler;
}
exports.ExplorerHandler = ExplorerHandler;
function initExplorerRegions(document) {
    return {
        speechRegion: new Region_js_1.LiveRegion(document),
        brailleRegion: new Region_js_1.LiveRegion(document),
        magnifier: new Region_js_1.HoverRegion(document),
        tooltip1: new Region_js_1.ToolTip(document),
        tooltip2: new Region_js_1.ToolTip(document),
        tooltip3: new Region_js_1.ToolTip(document)
    };
}
let allExplorers = {
    speech: (doc, node, ...rest) => {
        let explorer = ke.SpeechExplorer.create(doc, doc.explorerRegions.speechRegion, node, ...rest);
        explorer.speechGenerator.setOptions({
            locale: doc.options.sre.locale, domain: doc.options.sre.domain,
            style: doc.options.sre.style, modality: 'speech'
        });
        let locale = explorer.speechGenerator.getOptions().locale;
        if (locale !== sre_js_1.default.engineSetup().locale) {
            doc.options.sre.locale = sre_js_1.default.engineSetup().locale;
            explorer.speechGenerator.setOptions({ locale: doc.options.sre.locale });
        }
        explorer.showRegion = 'subtitles';
        return explorer;
    },
    braille: (doc, node, ...rest) => {
        let explorer = ke.SpeechExplorer.create(doc, doc.explorerRegions.brailleRegion, node, ...rest);
        explorer.speechGenerator.setOptions({ locale: 'nemeth', domain: 'default',
            style: 'default', modality: 'braille' });
        explorer.showRegion = 'viewBraille';
        return explorer;
    },
    keyMagnifier: (doc, node, ...rest) => ke.Magnifier.create(doc, doc.explorerRegions.magnifier, node, ...rest),
    mouseMagnifier: (doc, node, ..._rest) => me.ContentHoverer.create(doc, doc.explorerRegions.magnifier, node, (x) => x.hasAttribute('data-semantic-type'), (x) => x),
    hover: (doc, node, ..._rest) => me.FlameHoverer.create(doc, null, node),
    infoType: (doc, node, ..._rest) => me.ValueHoverer.create(doc, doc.explorerRegions.tooltip1, node, (x) => x.hasAttribute('data-semantic-type'), (x) => x.getAttribute('data-semantic-type')),
    infoRole: (doc, node, ..._rest) => me.ValueHoverer.create(doc, doc.explorerRegions.tooltip2, node, (x) => x.hasAttribute('data-semantic-role'), (x) => x.getAttribute('data-semantic-role')),
    infoPrefix: (doc, node, ..._rest) => me.ValueHoverer.create(doc, doc.explorerRegions.tooltip3, node, (x) => x.hasAttribute('data-semantic-prefix'), (x) => x.getAttribute('data-semantic-prefix')),
    flame: (doc, node, ..._rest) => TreeExplorer_js_1.FlameColorer.create(doc, null, node),
    treeColoring: (doc, node, ...rest) => TreeExplorer_js_1.TreeColorer.create(doc, null, node, ...rest)
};
function initExplorers(document, node, mml) {
    let explorers = {};
    for (let key of Object.keys(allExplorers)) {
        explorers[key] = allExplorers[key](document, node, mml);
    }
    return explorers;
}
function setA11yOptions(document, options) {
    let sreOptions = sre_js_1.default.engineSetup();
    for (let key in options) {
        if (document.options.a11y[key] !== undefined) {
            setA11yOption(document, key, options[key]);
            if (key === 'locale') {
                document.options.sre[key] = options[key];
            }
            continue;
        }
        if (sreOptions[key] !== undefined) {
            document.options.sre[key] = options[key];
        }
    }
    for (let item of document.math) {
        item.attachExplorers(document);
    }
}
exports.setA11yOptions = setA11yOptions;
function setA11yOption(document, option, value) {
    switch (option) {
        case 'magnification':
            switch (value) {
                case 'None':
                    document.options.a11y.magnification = value;
                    document.options.a11y.keyMagnifier = false;
                    document.options.a11y.mouseMagnifier = false;
                    break;
                case 'Keyboard':
                    document.options.a11y.magnification = value;
                    document.options.a11y.keyMagnifier = true;
                    document.options.a11y.mouseMagnifier = false;
                    break;
                case 'Mouse':
                    document.options.a11y.magnification = value;
                    document.options.a11y.keyMagnifier = false;
                    document.options.a11y.mouseMagnifier = true;
                    break;
            }
            break;
        case 'highlight':
            switch (value) {
                case 'None':
                    document.options.a11y.highlight = value;
                    document.options.a11y.hover = false;
                    document.options.a11y.flame = false;
                    break;
                case 'Hover':
                    document.options.a11y.highlight = value;
                    document.options.a11y.hover = true;
                    document.options.a11y.flame = false;
                    break;
                case 'Flame':
                    document.options.a11y.highlight = value;
                    document.options.a11y.hover = false;
                    document.options.a11y.flame = true;
                    break;
            }
            break;
        default:
            document.options.a11y[option] = value;
    }
}
exports.setA11yOption = setA11yOption;
let csPrefsSetting = {};
let csPrefsVariables = function (menu, prefs) {
    let srVariable = menu.pool.lookup('speechRules');
    for (let pref of prefs) {
        if (csPrefsSetting[pref])
            continue;
        menu.factory.get('variable')(menu.factory, {
            name: 'csprf_' + pref,
            setter: (value) => {
                csPrefsSetting[pref] = value;
                srVariable.setValue('clearspeak-' +
                    sre_js_1.default.clearspeakPreferences.addPreference(sre_js_1.default.clearspeakStyle(), pref, value));
            },
            getter: () => { return csPrefsSetting[pref] || 'Auto'; }
        }, menu.pool);
    }
};
let csSelectionBox = function (menu, locale) {
    let prefs = sre_js_1.default.clearspeakPreferences.getLocalePreferences();
    let props = prefs[locale];
    if (!props) {
        let csEntry = menu.findID('Accessibility', 'Speech', 'Clearspeak');
        if (csEntry) {
            csEntry.disable();
        }
        return null;
    }
    csPrefsVariables(menu, Object.keys(props));
    let items = [];
    for (const prop of Object.getOwnPropertyNames(props)) {
        items.push({
            'title': prop,
            'values': props[prop].map(x => x.replace(RegExp('^' + prop + '_'), '')),
            'variable': 'csprf_' + prop
        });
    }
    let sb = menu.factory.get('selectionBox')(menu.factory, {
        'title': 'Clearspeak Preferences',
        'signature': '',
        'order': 'alphabetic',
        'grid': 'square',
        'selections': items
    }, menu);
    return { 'type': 'command',
        'id': 'ClearspeakPreferences',
        'content': 'Select Preferences',
        'action': () => sb.post(0, 0) };
};
let csMenu = function (menu, sub) {
    let locale = menu.pool.lookup('locale').getValue();
    const box = csSelectionBox(menu, locale);
    let items = [];
    try {
        items = sre_js_1.default.clearspeakPreferences.smartPreferences(menu.mathItem, locale);
    }
    catch (e) {
        console.log(e);
    }
    if (box) {
        items.splice(2, 0, box);
    }
    return menu.factory.get('subMenu')(menu.factory, {
        items: items,
        id: 'Clearspeak'
    }, sub);
};
MJContextMenu_js_1.MJContextMenu.DynamicSubmenus.set('Clearspeak', csMenu);
let language = function (menu, sub) {
    let radios = [];
    for (let lang of sre_js_1.default.locales.keys()) {
        if (lang === 'nemeth')
            continue;
        radios.push({ type: 'radio', id: lang,
            content: sre_js_1.default.locales.get(lang) || lang, variable: 'locale' });
    }
    radios.sort((x, y) => x.content.localeCompare(y.content, 'en'));
    return menu.factory.get('subMenu')(menu.factory, {
        items: radios, id: 'Language'
    }, sub);
};
MJContextMenu_js_1.MJContextMenu.DynamicSubmenus.set('A11yLanguage', language);
//# sourceMappingURL=explorer.js.map