"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.TreeColorer = exports.FlameColorer = exports.AbstractTreeExplorer = void 0;
const Explorer_js_1 = require("./Explorer.js");
const sre_js_1 = __importDefault(require("../sre.js"));
class AbstractTreeExplorer extends Explorer_js_1.AbstractExplorer {
    constructor(document, region, node, mml) {
        super(document, null, node);
        this.document = document;
        this.region = region;
        this.node = node;
        this.mml = mml;
        this.stoppable = false;
    }
    Attach() {
        super.Attach();
        this.Start();
    }
    Detach() {
        this.Stop();
        super.Detach();
    }
}
exports.AbstractTreeExplorer = AbstractTreeExplorer;
class FlameColorer extends AbstractTreeExplorer {
    Start() {
        if (this.active)
            return;
        this.active = true;
        this.highlighter.highlightAll(this.node);
    }
    Stop() {
        if (this.active) {
            this.highlighter.unhighlightAll();
        }
        this.active = false;
    }
}
exports.FlameColorer = FlameColorer;
class TreeColorer extends AbstractTreeExplorer {
    Start() {
        if (this.active)
            return;
        this.active = true;
        let generator = sre_js_1.default.getSpeechGenerator('Color');
        if (!this.node.hasAttribute('hasforegroundcolor')) {
            generator.generateSpeech(this.node, this.mml);
            this.node.setAttribute('hasforegroundcolor', 'true');
        }
        this.highlighter.colorizeAll(this.node);
    }
    Stop() {
        if (this.active) {
            this.highlighter.uncolorizeAll(this.node);
        }
        this.active = false;
    }
}
exports.TreeColorer = TreeColorer;
//# sourceMappingURL=TreeExplorer.js.map