"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.sreReady = exports.Sre = void 0;
const Api = __importStar(require("speech-rule-engine/js/common/system.js"));
const WalkerFactory = __importStar(require("speech-rule-engine/js/walker/walker_factory.js"));
const SpeechGeneratorFactory = __importStar(require("speech-rule-engine/js/speech_generator/speech_generator_factory.js"));
const EngineConst = __importStar(require("speech-rule-engine/js/common/engine_const.js"));
const engine_js_1 = __importDefault(require("speech-rule-engine/js/common/engine.js"));
const clearspeak_preferences_js_1 = require("speech-rule-engine/js/speech_rules/clearspeak_preferences.js");
const HighlighterFactory = __importStar(require("speech-rule-engine/js/highlighter/highlighter_factory.js"));
const variables_js_1 = require("speech-rule-engine/js/common/variables.js");
const mathmaps_js_1 = __importDefault(require("./mathmaps.js"));
var Sre;
(function (Sre) {
    Sre.locales = variables_js_1.Variables.LOCALES;
    Sre.sreReady = Api.engineReady;
    Sre.setupEngine = Api.setupEngine;
    Sre.engineSetup = Api.engineSetup;
    Sre.toEnriched = Api.toEnriched;
    Sre.toSpeech = Api.toSpeech;
    Sre.clearspeakPreferences = clearspeak_preferences_js_1.ClearspeakPreferences;
    Sre.getHighlighter = HighlighterFactory.highlighter;
    Sre.getSpeechGenerator = SpeechGeneratorFactory.generator;
    Sre.getWalker = WalkerFactory.walker;
    Sre.clearspeakStyle = () => {
        return EngineConst.DOMAIN_TO_STYLES['clearspeak'];
    };
    Sre.preloadLocales = function (locale) {
        return __awaiter(this, void 0, void 0, function* () {
            const json = mathmaps_js_1.default.get(locale);
            return json ? new Promise((res, _rej) => res(JSON.stringify(json))) :
                Api.localeLoader()(locale);
        });
    };
})(Sre = exports.Sre || (exports.Sre = {}));
exports.sreReady = Sre.sreReady;
engine_js_1.default.getInstance().delay = true;
exports.default = Sre;
//# sourceMappingURL=sre.js.map