"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.MathJax = exports.combineWithMathJax = exports.combineDefaults = exports.combineConfig = exports.isObject = void 0;
const version_js_1 = require("./version.js");
function isObject(x) {
    return typeof x === 'object' && x !== null;
}
exports.isObject = isObject;
function combineConfig(dst, src) {
    for (const id of Object.keys(src)) {
        if (id === '__esModule')
            continue;
        if (isObject(dst[id]) && isObject(src[id]) &&
            !(src[id] instanceof Promise)) {
            combineConfig(dst[id], src[id]);
        }
        else if (src[id] !== null && src[id] !== undefined) {
            dst[id] = src[id];
        }
    }
    return dst;
}
exports.combineConfig = combineConfig;
function combineDefaults(dst, name, src) {
    if (!dst[name]) {
        dst[name] = {};
    }
    dst = dst[name];
    for (const id of Object.keys(src)) {
        if (isObject(dst[id]) && isObject(src[id])) {
            combineDefaults(dst, id, src[id]);
        }
        else if (dst[id] == null && src[id] != null) {
            dst[id] = src[id];
        }
    }
    return dst;
}
exports.combineDefaults = combineDefaults;
function combineWithMathJax(config) {
    return combineConfig(exports.MathJax, config);
}
exports.combineWithMathJax = combineWithMathJax;
if (typeof global.MathJax === 'undefined') {
    global.MathJax = {};
}
if (!global.MathJax.version) {
    global.MathJax = {
        version: version_js_1.VERSION,
        _: {},
        config: global.MathJax
    };
}
exports.MathJax = global.MathJax;
//# sourceMappingURL=global.js.map