"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.HandlerList = void 0;
const PrioritizedList_js_1 = require("../util/PrioritizedList.js");
class HandlerList extends PrioritizedList_js_1.PrioritizedList {
    register(handler) {
        return this.add(handler, handler.priority);
    }
    unregister(handler) {
        this.remove(handler);
    }
    handlesDocument(document) {
        for (const item of this) {
            let handler = item.item;
            if (handler.handlesDocument(document)) {
                return handler;
            }
        }
        throw new Error(`Can't find handler for document`);
    }
    document(document, options = null) {
        return this.handlesDocument(document).create(document, options);
    }
}
exports.HandlerList = HandlerList;
//# sourceMappingURL=HandlerList.js.map