"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.AbstractInputJax = void 0;
const Options_js_1 = require("../util/Options.js");
const FunctionList_js_1 = require("../util/FunctionList.js");
class AbstractInputJax {
    constructor(options = {}) {
        this.adaptor = null;
        this.mmlFactory = null;
        let CLASS = this.constructor;
        this.options = (0, Options_js_1.userOptions)((0, Options_js_1.defaultOptions)({}, CLASS.OPTIONS), options);
        this.preFilters = new FunctionList_js_1.FunctionList();
        this.postFilters = new FunctionList_js_1.FunctionList();
    }
    get name() {
        return this.constructor.NAME;
    }
    setAdaptor(adaptor) {
        this.adaptor = adaptor;
    }
    setMmlFactory(mmlFactory) {
        this.mmlFactory = mmlFactory;
    }
    initialize() {
    }
    reset(..._args) {
    }
    get processStrings() {
        return true;
    }
    findMath(_node, _options) {
        return [];
    }
    executeFilters(filters, math, document, data) {
        let args = { math: math, document: document, data: data };
        filters.execute(args);
        return args.data;
    }
}
exports.AbstractInputJax = AbstractInputJax;
AbstractInputJax.NAME = 'generic';
AbstractInputJax.OPTIONS = {};
//# sourceMappingURL=InputJax.js.map