"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.MML = void 0;
const MmlNode_js_1 = require("./MmlNode.js");
const math_js_1 = require("./MmlNodes/math.js");
const mi_js_1 = require("./MmlNodes/mi.js");
const mn_js_1 = require("./MmlNodes/mn.js");
const mo_js_1 = require("./MmlNodes/mo.js");
const mtext_js_1 = require("./MmlNodes/mtext.js");
const mspace_js_1 = require("./MmlNodes/mspace.js");
const ms_js_1 = require("./MmlNodes/ms.js");
const mrow_js_1 = require("./MmlNodes/mrow.js");
const mfrac_js_1 = require("./MmlNodes/mfrac.js");
const msqrt_js_1 = require("./MmlNodes/msqrt.js");
const mroot_js_1 = require("./MmlNodes/mroot.js");
const mstyle_js_1 = require("./MmlNodes/mstyle.js");
const merror_js_1 = require("./MmlNodes/merror.js");
const mpadded_js_1 = require("./MmlNodes/mpadded.js");
const mphantom_js_1 = require("./MmlNodes/mphantom.js");
const mfenced_js_1 = require("./MmlNodes/mfenced.js");
const menclose_js_1 = require("./MmlNodes/menclose.js");
const maction_js_1 = require("./MmlNodes/maction.js");
const msubsup_js_1 = require("./MmlNodes/msubsup.js");
const munderover_js_1 = require("./MmlNodes/munderover.js");
const mmultiscripts_js_1 = require("./MmlNodes/mmultiscripts.js");
const mtable_js_1 = require("./MmlNodes/mtable.js");
const mtr_js_1 = require("./MmlNodes/mtr.js");
const mtd_js_1 = require("./MmlNodes/mtd.js");
const maligngroup_js_1 = require("./MmlNodes/maligngroup.js");
const malignmark_js_1 = require("./MmlNodes/malignmark.js");
const mglyph_js_1 = require("./MmlNodes/mglyph.js");
const semantics_js_1 = require("./MmlNodes/semantics.js");
const TeXAtom_js_1 = require("./MmlNodes/TeXAtom.js");
const mathchoice_js_1 = require("./MmlNodes/mathchoice.js");
exports.MML = {
    [math_js_1.MmlMath.prototype.kind]: math_js_1.MmlMath,
    [mi_js_1.MmlMi.prototype.kind]: mi_js_1.MmlMi,
    [mn_js_1.MmlMn.prototype.kind]: mn_js_1.MmlMn,
    [mo_js_1.MmlMo.prototype.kind]: mo_js_1.MmlMo,
    [mtext_js_1.MmlMtext.prototype.kind]: mtext_js_1.MmlMtext,
    [mspace_js_1.MmlMspace.prototype.kind]: mspace_js_1.MmlMspace,
    [ms_js_1.MmlMs.prototype.kind]: ms_js_1.MmlMs,
    [mrow_js_1.MmlMrow.prototype.kind]: mrow_js_1.MmlMrow,
    [mrow_js_1.MmlInferredMrow.prototype.kind]: mrow_js_1.MmlInferredMrow,
    [mfrac_js_1.MmlMfrac.prototype.kind]: mfrac_js_1.MmlMfrac,
    [msqrt_js_1.MmlMsqrt.prototype.kind]: msqrt_js_1.MmlMsqrt,
    [mroot_js_1.MmlMroot.prototype.kind]: mroot_js_1.MmlMroot,
    [mstyle_js_1.MmlMstyle.prototype.kind]: mstyle_js_1.MmlMstyle,
    [merror_js_1.MmlMerror.prototype.kind]: merror_js_1.MmlMerror,
    [mpadded_js_1.MmlMpadded.prototype.kind]: mpadded_js_1.MmlMpadded,
    [mphantom_js_1.MmlMphantom.prototype.kind]: mphantom_js_1.MmlMphantom,
    [mfenced_js_1.MmlMfenced.prototype.kind]: mfenced_js_1.MmlMfenced,
    [menclose_js_1.MmlMenclose.prototype.kind]: menclose_js_1.MmlMenclose,
    [maction_js_1.MmlMaction.prototype.kind]: maction_js_1.MmlMaction,
    [msubsup_js_1.MmlMsub.prototype.kind]: msubsup_js_1.MmlMsub,
    [msubsup_js_1.MmlMsup.prototype.kind]: msubsup_js_1.MmlMsup,
    [msubsup_js_1.MmlMsubsup.prototype.kind]: msubsup_js_1.MmlMsubsup,
    [munderover_js_1.MmlMunder.prototype.kind]: munderover_js_1.MmlMunder,
    [munderover_js_1.MmlMover.prototype.kind]: munderover_js_1.MmlMover,
    [munderover_js_1.MmlMunderover.prototype.kind]: munderover_js_1.MmlMunderover,
    [mmultiscripts_js_1.MmlMmultiscripts.prototype.kind]: mmultiscripts_js_1.MmlMmultiscripts,
    [mmultiscripts_js_1.MmlMprescripts.prototype.kind]: mmultiscripts_js_1.MmlMprescripts,
    [mmultiscripts_js_1.MmlNone.prototype.kind]: mmultiscripts_js_1.MmlNone,
    [mtable_js_1.MmlMtable.prototype.kind]: mtable_js_1.MmlMtable,
    [mtr_js_1.MmlMlabeledtr.prototype.kind]: mtr_js_1.MmlMlabeledtr,
    [mtr_js_1.MmlMtr.prototype.kind]: mtr_js_1.MmlMtr,
    [mtd_js_1.MmlMtd.prototype.kind]: mtd_js_1.MmlMtd,
    [maligngroup_js_1.MmlMaligngroup.prototype.kind]: maligngroup_js_1.MmlMaligngroup,
    [malignmark_js_1.MmlMalignmark.prototype.kind]: malignmark_js_1.MmlMalignmark,
    [mglyph_js_1.MmlMglyph.prototype.kind]: mglyph_js_1.MmlMglyph,
    [semantics_js_1.MmlSemantics.prototype.kind]: semantics_js_1.MmlSemantics,
    [semantics_js_1.MmlAnnotation.prototype.kind]: semantics_js_1.MmlAnnotation,
    [semantics_js_1.MmlAnnotationXML.prototype.kind]: semantics_js_1.MmlAnnotationXML,
    [TeXAtom_js_1.TeXAtom.prototype.kind]: TeXAtom_js_1.TeXAtom,
    [mathchoice_js_1.MathChoice.prototype.kind]: mathchoice_js_1.MathChoice,
    [MmlNode_js_1.TextNode.prototype.kind]: MmlNode_js_1.TextNode,
    [MmlNode_js_1.XMLNode.prototype.kind]: MmlNode_js_1.XMLNode
};
//# sourceMappingURL=MML.js.map