"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.MmlMaction = void 0;
const MmlNode_js_1 = require("../MmlNode.js");
class MmlMaction extends MmlNode_js_1.AbstractMmlNode {
    get kind() {
        return 'maction';
    }
    get arity() {
        return 1;
    }
    get selected() {
        const selection = this.attributes.get('selection');
        const i = Math.max(1, Math.min(this.childNodes.length, selection)) - 1;
        return this.childNodes[i] || this.factory.create('mrow');
    }
    get isEmbellished() {
        return this.selected.isEmbellished;
    }
    get isSpacelike() {
        return this.selected.isSpacelike;
    }
    core() {
        return this.selected.core();
    }
    coreMO() {
        return this.selected.coreMO();
    }
    verifyAttributes(options) {
        super.verifyAttributes(options);
        if (this.attributes.get('actiontype') !== 'toggle' &&
            this.attributes.getExplicit('selection') !== undefined) {
            const attributes = this.attributes.getAllAttributes();
            delete attributes.selection;
        }
    }
    setTeXclass(prev) {
        if (this.attributes.get('actiontype') === 'tooltip' && this.childNodes[1]) {
            this.childNodes[1].setTeXclass(null);
        }
        let selected = this.selected;
        prev = selected.setTeXclass(prev);
        this.updateTeXclass(selected);
        return prev;
    }
    nextToggleSelection() {
        let selection = Math.max(1, this.attributes.get('selection') + 1);
        if (selection > this.childNodes.length) {
            selection = 1;
        }
        this.attributes.set('selection', selection);
    }
}
exports.MmlMaction = MmlMaction;
MmlMaction.defaults = Object.assign(Object.assign({}, MmlNode_js_1.AbstractMmlNode.defaults), { actiontype: 'toggle', selection: 1 });
//# sourceMappingURL=maction.js.map