"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.MmlMfrac = void 0;
const MmlNode_js_1 = require("../MmlNode.js");
class MmlMfrac extends MmlNode_js_1.AbstractMmlBaseNode {
    get kind() {
        return 'mfrac';
    }
    get arity() {
        return 2;
    }
    get linebreakContainer() {
        return true;
    }
    setTeXclass(prev) {
        this.getPrevClass(prev);
        for (const child of this.childNodes) {
            child.setTeXclass(null);
        }
        return this;
    }
    setChildInheritedAttributes(attributes, display, level, prime) {
        if (!display || level > 0) {
            level++;
        }
        this.childNodes[0].setInheritedAttributes(attributes, false, level, prime);
        this.childNodes[1].setInheritedAttributes(attributes, false, level, true);
    }
}
exports.MmlMfrac = MmlMfrac;
MmlMfrac.defaults = Object.assign(Object.assign({}, MmlNode_js_1.AbstractMmlBaseNode.defaults), { linethickness: 'medium', numalign: 'center', denomalign: 'center', bevelled: false });
//# sourceMappingURL=mfrac.js.map