"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.MmlMglyph = void 0;
const MmlNode_js_1 = require("../MmlNode.js");
class MmlMglyph extends MmlNode_js_1.AbstractMmlTokenNode {
    constructor() {
        super(...arguments);
        this.texclass = MmlNode_js_1.TEXCLASS.ORD;
    }
    get kind() {
        return 'mglyph';
    }
    verifyAttributes(options) {
        const { src, fontfamily, index } = this.attributes.getList('src', 'fontfamily', 'index');
        if (src === '' && (fontfamily === '' || index === '')) {
            this.mError('mglyph must have either src or fontfamily and index attributes', options, true);
        }
        else {
            super.verifyAttributes(options);
        }
    }
}
exports.MmlMglyph = MmlMglyph;
MmlMglyph.defaults = Object.assign(Object.assign({}, MmlNode_js_1.AbstractMmlTokenNode.defaults), { alt: '', src: '', index: '', width: 'auto', height: 'auto', valign: '0em' });
//# sourceMappingURL=mglyph.js.map