"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.MmlMspace = void 0;
const MmlNode_js_1 = require("../MmlNode.js");
class MmlMspace extends MmlNode_js_1.AbstractMmlTokenNode {
    constructor() {
        super(...arguments);
        this.texclass = MmlNode_js_1.TEXCLASS.NONE;
    }
    setTeXclass(prev) {
        return prev;
    }
    get kind() {
        return 'mspace';
    }
    get arity() {
        return 0;
    }
    get isSpacelike() {
        return true;
    }
    get hasNewline() {
        let attributes = this.attributes;
        return (attributes.getExplicit('width') == null && attributes.getExplicit('height') == null &&
            attributes.getExplicit('depth') == null && attributes.get('linebreak') === 'newline');
    }
}
exports.MmlMspace = MmlMspace;
MmlMspace.defaults = Object.assign(Object.assign({}, MmlNode_js_1.AbstractMmlTokenNode.defaults), { width: '0em', height: '0ex', depth: '0ex', linebreak: 'auto' });
//# sourceMappingURL=mspace.js.map