"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.MmlMstyle = void 0;
const MmlNode_js_1 = require("../MmlNode.js");
const Attributes_js_1 = require("../Attributes.js");
class MmlMstyle extends MmlNode_js_1.AbstractMmlLayoutNode {
    get kind() {
        return 'mstyle';
    }
    get notParent() {
        return this.childNodes[0] && this.childNodes[0].childNodes.length === 1;
    }
    setChildInheritedAttributes(attributes, display, level, prime) {
        let scriptlevel = this.attributes.getExplicit('scriptlevel');
        if (scriptlevel != null) {
            scriptlevel = scriptlevel.toString();
            if (scriptlevel.match(/^\s*[-+]/)) {
                level += parseInt(scriptlevel);
            }
            else {
                level = parseInt(scriptlevel);
            }
            prime = false;
        }
        let displaystyle = this.attributes.getExplicit('displaystyle');
        if (displaystyle != null) {
            display = (displaystyle === true);
            prime = false;
        }
        const cramped = this.attributes.getExplicit('data-cramped');
        if (cramped != null) {
            prime = cramped;
        }
        attributes = this.addInheritedAttributes(attributes, this.attributes.getAllAttributes());
        this.childNodes[0].setInheritedAttributes(attributes, display, level, prime);
    }
}
exports.MmlMstyle = MmlMstyle;
MmlMstyle.defaults = Object.assign(Object.assign({}, MmlNode_js_1.AbstractMmlLayoutNode.defaults), { scriptlevel: Attributes_js_1.INHERIT, displaystyle: Attributes_js_1.INHERIT, scriptsizemultiplier: 1 / Math.sqrt(2), scriptminsize: '8px', mathbackground: Attributes_js_1.INHERIT, mathcolor: Attributes_js_1.INHERIT, dir: Attributes_js_1.INHERIT, infixlinebreakstyle: 'before' });
//# sourceMappingURL=mstyle.js.map