"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.MmlMsup = exports.MmlMsub = exports.MmlMsubsup = void 0;
const MmlNode_js_1 = require("../MmlNode.js");
class MmlMsubsup extends MmlNode_js_1.AbstractMmlBaseNode {
    get kind() {
        return 'msubsup';
    }
    get arity() {
        return 3;
    }
    get base() {
        return 0;
    }
    get sub() {
        return 1;
    }
    get sup() {
        return 2;
    }
    setChildInheritedAttributes(attributes, display, level, prime) {
        let nodes = this.childNodes;
        nodes[0].setInheritedAttributes(attributes, display, level, prime);
        nodes[1].setInheritedAttributes(attributes, false, level + 1, prime || this.sub === 1);
        if (!nodes[2]) {
            return;
        }
        nodes[2].setInheritedAttributes(attributes, false, level + 1, prime || this.sub === 2);
    }
}
exports.MmlMsubsup = MmlMsubsup;
MmlMsubsup.defaults = Object.assign(Object.assign({}, MmlNode_js_1.AbstractMmlBaseNode.defaults), { subscriptshift: '', superscriptshift: '' });
class MmlMsub extends MmlMsubsup {
    get kind() {
        return 'msub';
    }
    get arity() {
        return 2;
    }
}
exports.MmlMsub = MmlMsub;
MmlMsub.defaults = Object.assign({}, MmlMsubsup.defaults);
class MmlMsup extends MmlMsubsup {
    get kind() {
        return 'msup';
    }
    get arity() {
        return 2;
    }
    get sup() {
        return 1;
    }
    get sub() {
        return 2;
    }
}
exports.MmlMsup = MmlMsup;
MmlMsup.defaults = Object.assign({}, MmlMsubsup.defaults);
//# sourceMappingURL=msubsup.js.map