"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.MmlMtd = void 0;
const MmlNode_js_1 = require("../MmlNode.js");
const Attributes_js_1 = require("../Attributes.js");
class MmlMtd extends MmlNode_js_1.AbstractMmlBaseNode {
    get kind() {
        return 'mtd';
    }
    get arity() {
        return -1;
    }
    get linebreakContainer() {
        return true;
    }
    verifyChildren(options) {
        if (this.parent && !this.parent.isKind('mtr')) {
            this.mError(this.kind + ' can only be a child of an mtr or mlabeledtr', options, true);
            return;
        }
        super.verifyChildren(options);
    }
    setTeXclass(prev) {
        this.getPrevClass(prev);
        this.childNodes[0].setTeXclass(null);
        return this;
    }
}
exports.MmlMtd = MmlMtd;
MmlMtd.defaults = Object.assign(Object.assign({}, MmlNode_js_1.AbstractMmlBaseNode.defaults), { rowspan: 1, columnspan: 1, rowalign: Attributes_js_1.INHERIT, columnalign: Attributes_js_1.INHERIT, groupalign: Attributes_js_1.INHERIT });
//# sourceMappingURL=mtd.js.map