"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.MmlMlabeledtr = exports.MmlMtr = void 0;
const MmlNode_js_1 = require("../MmlNode.js");
const Attributes_js_1 = require("../Attributes.js");
const string_js_1 = require("../../../util/string.js");
class MmlMtr extends MmlNode_js_1.AbstractMmlNode {
    get kind() {
        return 'mtr';
    }
    get linebreakContainer() {
        return true;
    }
    setChildInheritedAttributes(attributes, display, level, prime) {
        for (const child of this.childNodes) {
            if (!child.isKind('mtd')) {
                this.replaceChild(this.factory.create('mtd'), child)
                    .appendChild(child);
            }
        }
        const calign = (0, string_js_1.split)(this.attributes.get('columnalign'));
        if (this.arity === 1) {
            calign.unshift(this.parent.attributes.get('side'));
        }
        attributes = this.addInheritedAttributes(attributes, {
            rowalign: this.attributes.get('rowalign'),
            columnalign: 'center'
        });
        for (const child of this.childNodes) {
            attributes.columnalign[1] = calign.shift() || attributes.columnalign[1];
            child.setInheritedAttributes(attributes, display, level, prime);
        }
    }
    verifyChildren(options) {
        if (this.parent && !this.parent.isKind('mtable')) {
            this.mError(this.kind + ' can only be a child of an mtable', options, true);
            return;
        }
        for (const child of this.childNodes) {
            if (!child.isKind('mtd')) {
                let mtd = this.replaceChild(this.factory.create('mtd'), child);
                mtd.appendChild(child);
                if (!options['fixMtables']) {
                    child.mError('Children of ' + this.kind + ' must be mtd', options);
                }
            }
        }
        super.verifyChildren(options);
    }
    setTeXclass(prev) {
        this.getPrevClass(prev);
        for (const child of this.childNodes) {
            child.setTeXclass(null);
        }
        return this;
    }
}
exports.MmlMtr = MmlMtr;
MmlMtr.defaults = Object.assign(Object.assign({}, MmlNode_js_1.AbstractMmlNode.defaults), { rowalign: Attributes_js_1.INHERIT, columnalign: Attributes_js_1.INHERIT, groupalign: Attributes_js_1.INHERIT });
class MmlMlabeledtr extends MmlMtr {
    get kind() {
        return 'mlabeledtr';
    }
    get arity() {
        return 1;
    }
}
exports.MmlMlabeledtr = MmlMlabeledtr;
//# sourceMappingURL=mtr.js.map