"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.AbstractOutputJax = void 0;
const Options_js_1 = require("../util/Options.js");
const FunctionList_js_1 = require("../util/FunctionList.js");
class AbstractOutputJax {
    constructor(options = {}) {
        this.adaptor = null;
        let CLASS = this.constructor;
        this.options = (0, Options_js_1.userOptions)((0, Options_js_1.defaultOptions)({}, CLASS.OPTIONS), options);
        this.postFilters = new FunctionList_js_1.FunctionList();
    }
    get name() {
        return this.constructor.NAME;
    }
    setAdaptor(adaptor) {
        this.adaptor = adaptor;
    }
    initialize() {
    }
    reset(..._args) {
    }
    getMetrics(_document) {
    }
    styleSheet(_document) {
        return null;
    }
    pageElements(_document) {
        return null;
    }
    executeFilters(filters, math, document, data) {
        let args = { math, document, data };
        filters.execute(args);
        return args.data;
    }
}
exports.AbstractOutputJax = AbstractOutputJax;
AbstractOutputJax.NAME = 'generic';
AbstractOutputJax.OPTIONS = {};
//# sourceMappingURL=OutputJax.js.map