"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.HTMLHandler = void 0;
const Handler_js_1 = require("../../core/Handler.js");
const HTMLDocument_js_1 = require("./HTMLDocument.js");
class HTMLHandler extends Handler_js_1.AbstractHandler {
    constructor() {
        super(...arguments);
        this.documentClass = HTMLDocument_js_1.HTMLDocument;
    }
    handlesDocument(document) {
        const adaptor = this.adaptor;
        if (typeof (document) === 'string') {
            try {
                document = adaptor.parse(document, 'text/html');
            }
            catch (err) { }
        }
        if (document instanceof adaptor.window.Document ||
            document instanceof adaptor.window.HTMLElement ||
            document instanceof adaptor.window.DocumentFragment) {
            return true;
        }
        return false;
    }
    create(document, options) {
        const adaptor = this.adaptor;
        if (typeof (document) === 'string') {
            document = adaptor.parse(document, 'text/html');
        }
        else if (document instanceof adaptor.window.HTMLElement ||
            document instanceof adaptor.window.DocumentFragment) {
            let child = document;
            document = adaptor.parse('', 'text/html');
            adaptor.append(adaptor.body(document), child);
        }
        return super.create(document, options);
    }
}
exports.HTMLHandler = HTMLHandler;
//# sourceMappingURL=HTMLHandler.js.map