"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.AsciiMath = void 0;
const InputJax_js_1 = require("../core/InputJax.js");
const AsciiMath_js_1 = require("./asciimath/mathjax2/input/AsciiMath.js");
const Options_js_1 = require("../util/Options.js");
const FindAsciiMath_js_1 = require("./asciimath/FindAsciiMath.js");
class AsciiMath extends InputJax_js_1.AbstractInputJax {
    constructor(options) {
        let [, find, am] = (0, Options_js_1.separateOptions)(options, FindAsciiMath_js_1.FindAsciiMath.OPTIONS, AsciiMath.OPTIONS);
        super(am);
        this.findAsciiMath = this.options['FindAsciiMath'] || new FindAsciiMath_js_1.FindAsciiMath(find);
    }
    compile(math, _document) {
        return AsciiMath_js_1.LegacyAsciiMath.Compile(math.math, math.display);
    }
    findMath(strings) {
        return this.findAsciiMath.findMath(strings);
    }
}
exports.AsciiMath = AsciiMath;
AsciiMath.NAME = 'AsciiMath';
AsciiMath.OPTIONS = Object.assign(Object.assign({}, InputJax_js_1.AbstractInputJax.OPTIONS), { FindAsciiMath: null });
//# sourceMappingURL=asciimath.js.map