"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.AmsConfiguration = exports.AmsTags = void 0;
const Configuration_js_1 = require("../Configuration.js");
const AmsItems_js_1 = require("./AmsItems.js");
const Tags_js_1 = require("../Tags.js");
const AmsMethods_js_1 = require("./AmsMethods.js");
require("./AmsMappings.js");
const SymbolMap_js_1 = require("../SymbolMap.js");
class AmsTags extends Tags_js_1.AbstractTags {
}
exports.AmsTags = AmsTags;
let init = function (config) {
    new SymbolMap_js_1.CommandMap(AmsMethods_js_1.NEW_OPS, {}, {});
    config.append(Configuration_js_1.Configuration.local({ handler: { macro: [AmsMethods_js_1.NEW_OPS] },
        priority: -1 }));
};
exports.AmsConfiguration = Configuration_js_1.Configuration.create('ams', {
    handler: {
        character: ['AMSmath-operatorLetter'],
        delimiter: ['AMSsymbols-delimiter', 'AMSmath-delimiter'],
        macro: ['AMSsymbols-mathchar0mi', 'AMSsymbols-mathchar0mo',
            'AMSsymbols-delimiter', 'AMSsymbols-macros',
            'AMSmath-mathchar0mo', 'AMSmath-macros', 'AMSmath-delimiter'],
        environment: ['AMSmath-environment']
    },
    items: {
        [AmsItems_js_1.MultlineItem.prototype.kind]: AmsItems_js_1.MultlineItem,
        [AmsItems_js_1.FlalignItem.prototype.kind]: AmsItems_js_1.FlalignItem,
    },
    tags: { 'ams': AmsTags },
    init: init,
    config: (_config, jax) => {
        if (jax.parseOptions.options.multlineWidth) {
            jax.parseOptions.options.ams.multlineWidth = jax.parseOptions.options.multlineWidth;
        }
        delete jax.parseOptions.options.multlineWidth;
    },
    options: {
        multlineWidth: '',
        ams: {
            multlineWidth: '100%',
            multlineIndent: '1em',
        }
    }
});
//# sourceMappingURL=AmsConfiguration.js.map