"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.BaseConfiguration = exports.BaseTags = exports.Other = void 0;
const Configuration_js_1 = require("../Configuration.js");
const MapHandler_js_1 = require("../MapHandler.js");
const TexError_js_1 = __importDefault(require("../TexError.js"));
const NodeUtil_js_1 = __importDefault(require("../NodeUtil.js"));
const SymbolMap_js_1 = require("../SymbolMap.js");
const bitem = __importStar(require("./BaseItems.js"));
const Tags_js_1 = require("../Tags.js");
require("./BaseMappings.js");
const OperatorDictionary_js_1 = require("../../../core/MmlTree/OperatorDictionary.js");
new SymbolMap_js_1.CharacterMap('remap', null, {
    '-': '\u2212',
    '*': '\u2217',
    '`': '\u2018'
});
function Other(parser, char) {
    const font = parser.stack.env['font'];
    let def = font ?
        { mathvariant: parser.stack.env['font'] } : {};
    const remap = MapHandler_js_1.MapHandler.getMap('remap').lookup(char);
    const range = (0, OperatorDictionary_js_1.getRange)(char);
    const type = (range ? range[3] : 'mo');
    let mo = parser.create('token', type, def, (remap ? remap.char : char));
    range[4] && mo.attributes.set('mathvariant', range[4]);
    if (type === 'mo') {
        NodeUtil_js_1.default.setProperty(mo, 'fixStretchy', true);
        parser.configuration.addNode('fixStretchy', mo);
    }
    parser.Push(mo);
}
exports.Other = Other;
function csUndefined(_parser, name) {
    throw new TexError_js_1.default('UndefinedControlSequence', 'Undefined control sequence %1', '\\' + name);
}
function envUndefined(_parser, env) {
    throw new TexError_js_1.default('UnknownEnv', 'Unknown environment \'%1\'', env);
}
function filterNonscript({ data }) {
    for (const mml of data.getList('nonscript')) {
        if (mml.attributes.get('scriptlevel') > 0) {
            const parent = mml.parent;
            parent.childNodes.splice(parent.childIndex(mml), 1);
            data.removeFromList(mml.kind, [mml]);
            if (mml.isKind('mrow')) {
                const mstyle = mml.childNodes[0];
                data.removeFromList('mstyle', [mstyle]);
                data.removeFromList('mspace', mstyle.childNodes[0].childNodes);
            }
        }
        else if (mml.isKind('mrow')) {
            mml.parent.replaceChild(mml.childNodes[0], mml);
            data.removeFromList('mrow', [mml]);
        }
    }
}
class BaseTags extends Tags_js_1.AbstractTags {
}
exports.BaseTags = BaseTags;
exports.BaseConfiguration = Configuration_js_1.Configuration.create('base', {
    handler: {
        character: ['command', 'special', 'letter', 'digit'],
        delimiter: ['delimiter'],
        macro: ['delimiter', 'macros', 'mathchar0mi', 'mathchar0mo', 'mathchar7'],
        environment: ['environment']
    },
    fallback: {
        character: Other,
        macro: csUndefined,
        environment: envUndefined
    },
    items: {
        [bitem.StartItem.prototype.kind]: bitem.StartItem,
        [bitem.StopItem.prototype.kind]: bitem.StopItem,
        [bitem.OpenItem.prototype.kind]: bitem.OpenItem,
        [bitem.CloseItem.prototype.kind]: bitem.CloseItem,
        [bitem.PrimeItem.prototype.kind]: bitem.PrimeItem,
        [bitem.SubsupItem.prototype.kind]: bitem.SubsupItem,
        [bitem.OverItem.prototype.kind]: bitem.OverItem,
        [bitem.LeftItem.prototype.kind]: bitem.LeftItem,
        [bitem.Middle.prototype.kind]: bitem.Middle,
        [bitem.RightItem.prototype.kind]: bitem.RightItem,
        [bitem.BeginItem.prototype.kind]: bitem.BeginItem,
        [bitem.EndItem.prototype.kind]: bitem.EndItem,
        [bitem.StyleItem.prototype.kind]: bitem.StyleItem,
        [bitem.PositionItem.prototype.kind]: bitem.PositionItem,
        [bitem.CellItem.prototype.kind]: bitem.CellItem,
        [bitem.MmlItem.prototype.kind]: bitem.MmlItem,
        [bitem.FnItem.prototype.kind]: bitem.FnItem,
        [bitem.NotItem.prototype.kind]: bitem.NotItem,
        [bitem.NonscriptItem.prototype.kind]: bitem.NonscriptItem,
        [bitem.DotsItem.prototype.kind]: bitem.DotsItem,
        [bitem.ArrayItem.prototype.kind]: bitem.ArrayItem,
        [bitem.EqnArrayItem.prototype.kind]: bitem.EqnArrayItem,
        [bitem.EquationItem.prototype.kind]: bitem.EquationItem
    },
    options: {
        maxMacros: 1000,
        baseURL: (typeof (document) === 'undefined' ||
            document.getElementsByTagName('base').length === 0) ?
            '' : String(document.location).replace(/#.*$/, '')
    },
    tags: {
        base: BaseTags
    },
    postprocessors: [[filterNonscript, -4]]
});
//# sourceMappingURL=BaseConfiguration.js.map