"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.BussproofsConfiguration = void 0;
const Configuration_js_1 = require("../Configuration.js");
const BussproofsItems_js_1 = require("./BussproofsItems.js");
const BussproofsUtil_js_1 = require("./BussproofsUtil.js");
require("./BussproofsMappings.js");
exports.BussproofsConfiguration = Configuration_js_1.Configuration.create('bussproofs', {
    handler: {
        macro: ['Bussproofs-macros'],
        environment: ['Bussproofs-environments']
    },
    items: {
        [BussproofsItems_js_1.ProofTreeItem.prototype.kind]: BussproofsItems_js_1.ProofTreeItem,
    },
    preprocessors: [
        [BussproofsUtil_js_1.saveDocument, 1]
    ],
    postprocessors: [
        [BussproofsUtil_js_1.clearDocument, 3],
        [BussproofsUtil_js_1.makeBsprAttributes, 2],
        [BussproofsUtil_js_1.balanceRules, 1]
    ]
});
//# sourceMappingURL=BussproofsConfiguration.js.map