"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.MultlinedItem = void 0;
const AmsItems_js_1 = require("../ams/AmsItems.js");
const NodeUtil_js_1 = __importDefault(require("../NodeUtil.js"));
const TexConstants_js_1 = require("../TexConstants.js");
class MultlinedItem extends AmsItems_js_1.MultlineItem {
    get kind() {
        return 'multlined';
    }
    EndTable() {
        if (this.Size() || this.row.length) {
            this.EndEntry();
            this.EndRow();
        }
        if (this.table.length > 1) {
            const options = this.factory.configuration.options.mathtools;
            const gap = options.multlinegap;
            const firstskip = options['firstline-afterskip'] || gap;
            const lastskip = options['lastline-preskip'] || gap;
            const first = NodeUtil_js_1.default.getChildren(this.table[0])[0];
            if (NodeUtil_js_1.default.getAttribute(first, 'columnalign') !== TexConstants_js_1.TexConstant.Align.RIGHT) {
                first.appendChild(this.create('node', 'mspace', [], { width: firstskip }));
            }
            const last = NodeUtil_js_1.default.getChildren(this.table[this.table.length - 1])[0];
            if (NodeUtil_js_1.default.getAttribute(last, 'columnalign') !== TexConstants_js_1.TexConstant.Align.LEFT) {
                const top = NodeUtil_js_1.default.getChildren(last)[0];
                top.childNodes.unshift(null);
                const space = this.create('node', 'mspace', [], { width: lastskip });
                NodeUtil_js_1.default.setChild(top, 0, space);
            }
        }
        super.EndTable.call(this);
    }
}
exports.MultlinedItem = MultlinedItem;
//# sourceMappingURL=MathtoolsItems.js.map