"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.TagFormatConfiguration = exports.tagformatConfig = void 0;
const Configuration_js_1 = require("../Configuration.js");
const Tags_js_1 = require("../Tags.js");
let tagID = 0;
function tagformatConfig(config, jax) {
    const tags = jax.parseOptions.options.tags;
    if (tags !== 'base' && config.tags.hasOwnProperty(tags)) {
        Tags_js_1.TagsFactory.add(tags, config.tags[tags]);
    }
    const TagClass = Tags_js_1.TagsFactory.create(jax.parseOptions.options.tags).constructor;
    class TagFormat extends TagClass {
        formatNumber(n) {
            return jax.parseOptions.options.tagformat.number(n);
        }
        formatTag(tag) {
            return jax.parseOptions.options.tagformat.tag(tag);
        }
        formatId(id) {
            return jax.parseOptions.options.tagformat.id(id);
        }
        formatUrl(id, base) {
            return jax.parseOptions.options.tagformat.url(id, base);
        }
    }
    tagID++;
    const tagName = 'configTags-' + tagID;
    Tags_js_1.TagsFactory.add(tagName, TagFormat);
    jax.parseOptions.options.tags = tagName;
}
exports.tagformatConfig = tagformatConfig;
exports.TagFormatConfiguration = Configuration_js_1.Configuration.create('tagformat', {
    config: [tagformatConfig, 10],
    options: {
        tagformat: {
            number: (n) => n.toString(),
            tag: (tag) => '(' + tag + ')',
            id: (id) => 'mjx-eqn:' + id.replace(/\s/g, '_'),
            url: (id, base) => base + '#' + encodeURIComponent(id),
        }
    }
});
//# sourceMappingURL=TagFormatConfiguration.js.map