"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.CHTMLWrappers = void 0;
const Wrapper_js_1 = require("./Wrapper.js");
const math_js_1 = require("./Wrappers/math.js");
const mi_js_1 = require("./Wrappers/mi.js");
const mo_js_1 = require("./Wrappers/mo.js");
const mn_js_1 = require("./Wrappers/mn.js");
const ms_js_1 = require("./Wrappers/ms.js");
const mtext_js_1 = require("./Wrappers/mtext.js");
const mspace_js_1 = require("./Wrappers/mspace.js");
const mpadded_js_1 = require("./Wrappers/mpadded.js");
const menclose_js_1 = require("./Wrappers/menclose.js");
const mrow_js_1 = require("./Wrappers/mrow.js");
const mfenced_js_1 = require("./Wrappers/mfenced.js");
const mfrac_js_1 = require("./Wrappers/mfrac.js");
const msqrt_js_1 = require("./Wrappers/msqrt.js");
const mroot_js_1 = require("./Wrappers/mroot.js");
const msubsup_js_1 = require("./Wrappers/msubsup.js");
const munderover_js_1 = require("./Wrappers/munderover.js");
const mmultiscripts_js_1 = require("./Wrappers/mmultiscripts.js");
const mtable_js_1 = require("./Wrappers/mtable.js");
const mtr_js_1 = require("./Wrappers/mtr.js");
const mtd_js_1 = require("./Wrappers/mtd.js");
const maction_js_1 = require("./Wrappers/maction.js");
const mglyph_js_1 = require("./Wrappers/mglyph.js");
const semantics_js_1 = require("./Wrappers/semantics.js");
const TeXAtom_js_1 = require("./Wrappers/TeXAtom.js");
const TextNode_js_1 = require("./Wrappers/TextNode.js");
exports.CHTMLWrappers = {
    [math_js_1.CHTMLmath.kind]: math_js_1.CHTMLmath,
    [mrow_js_1.CHTMLmrow.kind]: mrow_js_1.CHTMLmrow,
    [mrow_js_1.CHTMLinferredMrow.kind]: mrow_js_1.CHTMLinferredMrow,
    [mi_js_1.CHTMLmi.kind]: mi_js_1.CHTMLmi,
    [mo_js_1.CHTMLmo.kind]: mo_js_1.CHTMLmo,
    [mn_js_1.CHTMLmn.kind]: mn_js_1.CHTMLmn,
    [ms_js_1.CHTMLms.kind]: ms_js_1.CHTMLms,
    [mtext_js_1.CHTMLmtext.kind]: mtext_js_1.CHTMLmtext,
    [mspace_js_1.CHTMLmspace.kind]: mspace_js_1.CHTMLmspace,
    [mpadded_js_1.CHTMLmpadded.kind]: mpadded_js_1.CHTMLmpadded,
    [menclose_js_1.CHTMLmenclose.kind]: menclose_js_1.CHTMLmenclose,
    [mfrac_js_1.CHTMLmfrac.kind]: mfrac_js_1.CHTMLmfrac,
    [msqrt_js_1.CHTMLmsqrt.kind]: msqrt_js_1.CHTMLmsqrt,
    [mroot_js_1.CHTMLmroot.kind]: mroot_js_1.CHTMLmroot,
    [msubsup_js_1.CHTMLmsub.kind]: msubsup_js_1.CHTMLmsub,
    [msubsup_js_1.CHTMLmsup.kind]: msubsup_js_1.CHTMLmsup,
    [msubsup_js_1.CHTMLmsubsup.kind]: msubsup_js_1.CHTMLmsubsup,
    [munderover_js_1.CHTMLmunder.kind]: munderover_js_1.CHTMLmunder,
    [munderover_js_1.CHTMLmover.kind]: munderover_js_1.CHTMLmover,
    [munderover_js_1.CHTMLmunderover.kind]: munderover_js_1.CHTMLmunderover,
    [mmultiscripts_js_1.CHTMLmmultiscripts.kind]: mmultiscripts_js_1.CHTMLmmultiscripts,
    [mfenced_js_1.CHTMLmfenced.kind]: mfenced_js_1.CHTMLmfenced,
    [mtable_js_1.CHTMLmtable.kind]: mtable_js_1.CHTMLmtable,
    [mtr_js_1.CHTMLmtr.kind]: mtr_js_1.CHTMLmtr,
    [mtr_js_1.CHTMLmlabeledtr.kind]: mtr_js_1.CHTMLmlabeledtr,
    [mtd_js_1.CHTMLmtd.kind]: mtd_js_1.CHTMLmtd,
    [maction_js_1.CHTMLmaction.kind]: maction_js_1.CHTMLmaction,
    [mglyph_js_1.CHTMLmglyph.kind]: mglyph_js_1.CHTMLmglyph,
    [semantics_js_1.CHTMLsemantics.kind]: semantics_js_1.CHTMLsemantics,
    [semantics_js_1.CHTMLannotation.kind]: semantics_js_1.CHTMLannotation,
    [semantics_js_1.CHTMLannotationXML.kind]: semantics_js_1.CHTMLannotationXML,
    [semantics_js_1.CHTMLxml.kind]: semantics_js_1.CHTMLxml,
    [TeXAtom_js_1.CHTMLTeXAtom.kind]: TeXAtom_js_1.CHTMLTeXAtom,
    [TextNode_js_1.CHTMLTextNode.kind]: TextNode_js_1.CHTMLTextNode,
    [Wrapper_js_1.CHTMLWrapper.kind]: Wrapper_js_1.CHTMLWrapper
};
//# sourceMappingURL=Wrappers.js.map