"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.CHTMLTeXAtom = void 0;
const Wrapper_js_1 = require("../Wrapper.js");
const TeXAtom_js_1 = require("../../common/Wrappers/TeXAtom.js");
const TeXAtom_js_2 = require("../../../core/MmlTree/MmlNodes/TeXAtom.js");
const MmlNode_js_1 = require("../../../core/MmlTree/MmlNode.js");
class CHTMLTeXAtom extends (0, TeXAtom_js_1.CommonTeXAtomMixin)(Wrapper_js_1.CHTMLWrapper) {
    toCHTML(parent) {
        super.toCHTML(parent);
        this.adaptor.setAttribute(this.chtml, 'texclass', MmlNode_js_1.TEXCLASSNAMES[this.node.texClass]);
        if (this.node.texClass === MmlNode_js_1.TEXCLASS.VCENTER) {
            const bbox = this.childNodes[0].getBBox();
            const { h, d } = bbox;
            const a = this.font.params.axis_height;
            const dh = ((h + d) / 2 + a) - h;
            this.adaptor.setStyle(this.chtml, 'verticalAlign', this.em(dh));
        }
    }
}
exports.CHTMLTeXAtom = CHTMLTeXAtom;
CHTMLTeXAtom.kind = TeXAtom_js_2.TeXAtom.prototype.kind;
//# sourceMappingURL=TeXAtom.js.map