"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.CHTMLTextNode = void 0;
const MmlNode_js_1 = require("../../../core/MmlTree/MmlNode.js");
const Wrapper_js_1 = require("../Wrapper.js");
const TextNode_js_1 = require("../../common/Wrappers/TextNode.js");
class CHTMLTextNode extends (0, TextNode_js_1.CommonTextNodeMixin)(Wrapper_js_1.CHTMLWrapper) {
    toCHTML(parent) {
        this.markUsed();
        const adaptor = this.adaptor;
        const variant = this.parent.variant;
        const text = this.node.getText();
        if (text.length === 0)
            return;
        if (variant === '-explicitFont') {
            adaptor.append(parent, this.jax.unknownText(text, variant, this.getBBox().w));
        }
        else {
            const chars = this.remappedText(text, variant);
            for (const n of chars) {
                const data = this.getVariantChar(variant, n)[3];
                const font = (data.f ? ' TEX-' + data.f : '');
                const node = (data.unknown ?
                    this.jax.unknownText(String.fromCodePoint(n), variant) :
                    this.html('mjx-c', { class: this.char(n) + font }));
                adaptor.append(parent, node);
                !data.unknown && this.font.charUsage.add([variant, n]);
            }
        }
    }
}
exports.CHTMLTextNode = CHTMLTextNode;
CHTMLTextNode.kind = MmlNode_js_1.TextNode.prototype.kind;
CHTMLTextNode.autoStyle = false;
CHTMLTextNode.styles = {
    'mjx-c': {
        display: 'inline-block'
    },
    'mjx-utext': {
        display: 'inline-block',
        padding: '.75em 0 .2em 0'
    }
};
//# sourceMappingURL=TextNode.js.map