"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.CHTMLmglyph = void 0;
const Wrapper_js_1 = require("../Wrapper.js");
const mglyph_js_1 = require("../../common/Wrappers/mglyph.js");
const mglyph_js_2 = require("../../../core/MmlTree/MmlNodes/mglyph.js");
class CHTMLmglyph extends (0, mglyph_js_1.CommonMglyphMixin)(Wrapper_js_1.CHTMLWrapper) {
    toCHTML(parent) {
        const chtml = this.standardCHTMLnode(parent);
        if (this.charWrapper) {
            this.charWrapper.toCHTML(chtml);
            return;
        }
        const { src, alt } = this.node.attributes.getList('src', 'alt');
        const styles = {
            width: this.em(this.width),
            height: this.em(this.height)
        };
        if (this.valign) {
            styles.verticalAlign = this.em(this.valign);
        }
        const img = this.html('img', { src: src, style: styles, alt: alt, title: alt });
        this.adaptor.append(chtml, img);
    }
}
exports.CHTMLmglyph = CHTMLmglyph;
CHTMLmglyph.kind = mglyph_js_2.MmlMglyph.prototype.kind;
CHTMLmglyph.styles = {
    'mjx-mglyph > img': {
        display: 'inline-block',
        border: 0,
        padding: 0
    }
};
//# sourceMappingURL=mglyph.js.map