"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.CHTMLmmultiscripts = void 0;
const msubsup_js_1 = require("./msubsup.js");
const mmultiscripts_js_1 = require("../../common/Wrappers/mmultiscripts.js");
const mmultiscripts_js_2 = require("../../../core/MmlTree/MmlNodes/mmultiscripts.js");
const string_js_1 = require("../../../util/string.js");
class CHTMLmmultiscripts extends (0, mmultiscripts_js_1.CommonMmultiscriptsMixin)(msubsup_js_1.CHTMLmsubsup) {
    toCHTML(parent) {
        const chtml = this.standardCHTMLnode(parent);
        const data = this.scriptData;
        const scriptalign = this.node.getProperty('scriptalign') || 'right left';
        const [preAlign, postAlign] = (0, string_js_1.split)(scriptalign + ' ' + scriptalign);
        const sub = this.combinePrePost(data.sub, data.psub);
        const sup = this.combinePrePost(data.sup, data.psup);
        const [u, v] = this.getUVQ(sub, sup);
        if (data.numPrescripts) {
            const scripts = this.addScripts(u, -v, true, data.psub, data.psup, this.firstPrescript, data.numPrescripts);
            preAlign !== 'right' && this.adaptor.setAttribute(scripts, 'script-align', preAlign);
        }
        this.childNodes[0].toCHTML(chtml);
        if (data.numScripts) {
            const scripts = this.addScripts(u, -v, false, data.sub, data.sup, 1, data.numScripts);
            postAlign !== 'left' && this.adaptor.setAttribute(scripts, 'script-align', postAlign);
        }
    }
    addScripts(u, v, isPre, sub, sup, i, n) {
        const adaptor = this.adaptor;
        const q = (u - sup.d) + (v - sub.h);
        const U = (u < 0 && v === 0 ? sub.h + u : u);
        const rowdef = (q > 0 ? { style: { height: this.em(q) } } : {});
        const tabledef = (U ? { style: { 'vertical-align': this.em(U) } } : {});
        const supRow = this.html('mjx-row');
        const sepRow = this.html('mjx-row', rowdef);
        const subRow = this.html('mjx-row');
        const name = 'mjx-' + (isPre ? 'pre' : '') + 'scripts';
        let m = i + 2 * n;
        while (i < m) {
            this.childNodes[i++].toCHTML(adaptor.append(subRow, this.html('mjx-cell')));
            this.childNodes[i++].toCHTML(adaptor.append(supRow, this.html('mjx-cell')));
        }
        return adaptor.append(this.chtml, this.html(name, tabledef, [supRow, sepRow, subRow]));
    }
}
exports.CHTMLmmultiscripts = CHTMLmmultiscripts;
CHTMLmmultiscripts.kind = mmultiscripts_js_2.MmlMmultiscripts.prototype.kind;
CHTMLmmultiscripts.styles = {
    'mjx-prescripts': {
        display: 'inline-table',
        'padding-left': '.05em'
    },
    'mjx-scripts': {
        display: 'inline-table',
        'padding-right': '.05em'
    },
    'mjx-prescripts > mjx-row > mjx-cell': {
        'text-align': 'right'
    },
    '[script-align="left"] > mjx-row > mjx-cell': {
        'text-align': 'left'
    },
    '[script-align="center"] > mjx-row > mjx-cell': {
        'text-align': 'center'
    },
    '[script-align="right"] > mjx-row > mjx-cell': {
        'text-align': 'right'
    }
};
//# sourceMappingURL=mmultiscripts.js.map