"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.CHTMLmpadded = void 0;
const Wrapper_js_1 = require("../Wrapper.js");
const mpadded_js_1 = require("../../common/Wrappers/mpadded.js");
const mpadded_js_2 = require("../../../core/MmlTree/MmlNodes/mpadded.js");
class CHTMLmpadded extends (0, mpadded_js_1.CommonMpaddedMixin)(Wrapper_js_1.CHTMLWrapper) {
    toCHTML(parent) {
        let chtml = this.standardCHTMLnode(parent);
        const content = [];
        const style = {};
        const [, , W, dh, dd, dw, x, y, dx] = this.getDimens();
        if (dw) {
            style.width = this.em(W + dw);
        }
        if (dh || dd) {
            style.margin = this.em(dh) + ' 0 ' + this.em(dd);
        }
        if (x + dx || y) {
            style.position = 'relative';
            const rbox = this.html('mjx-rbox', {
                style: { left: this.em(x + dx), top: this.em(-y), 'max-width': style.width }
            });
            if (x + dx && this.childNodes[0].getBBox().pwidth) {
                this.adaptor.setAttribute(rbox, 'width', 'full');
                this.adaptor.setStyle(rbox, 'left', this.em(x));
            }
            content.push(rbox);
        }
        chtml = this.adaptor.append(chtml, this.html('mjx-block', { style: style }, content));
        for (const child of this.childNodes) {
            child.toCHTML(content[0] || chtml);
        }
    }
}
exports.CHTMLmpadded = CHTMLmpadded;
CHTMLmpadded.kind = mpadded_js_2.MmlMpadded.prototype.kind;
CHTMLmpadded.styles = {
    'mjx-mpadded': {
        display: 'inline-block'
    },
    'mjx-rbox': {
        display: 'inline-block',
        position: 'relative'
    }
};
//# sourceMappingURL=mpadded.js.map