"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.CHTMLinferredMrow = exports.CHTMLmrow = void 0;
const Wrapper_js_1 = require("../Wrapper.js");
const mrow_js_1 = require("../../common/Wrappers/mrow.js");
const mrow_js_2 = require("../../common/Wrappers/mrow.js");
const mrow_js_3 = require("../../../core/MmlTree/MmlNodes/mrow.js");
class CHTMLmrow extends (0, mrow_js_1.CommonMrowMixin)(Wrapper_js_1.CHTMLWrapper) {
    toCHTML(parent) {
        const chtml = (this.node.isInferred ? (this.chtml = parent) : this.standardCHTMLnode(parent));
        let hasNegative = false;
        for (const child of this.childNodes) {
            child.toCHTML(chtml);
            if (child.bbox.w < 0) {
                hasNegative = true;
            }
        }
        if (hasNegative) {
            const { w } = this.getBBox();
            if (w) {
                this.adaptor.setStyle(chtml, 'width', this.em(Math.max(0, w)));
                if (w < 0) {
                    this.adaptor.setStyle(chtml, 'marginRight', this.em(w));
                }
            }
        }
    }
}
exports.CHTMLmrow = CHTMLmrow;
CHTMLmrow.kind = mrow_js_3.MmlMrow.prototype.kind;
class CHTMLinferredMrow extends (0, mrow_js_2.CommonInferredMrowMixin)(CHTMLmrow) {
}
exports.CHTMLinferredMrow = CHTMLinferredMrow;
CHTMLinferredMrow.kind = mrow_js_3.MmlInferredMrow.prototype.kind;
//# sourceMappingURL=mrow.js.map