"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.CHTMLmspace = void 0;
const Wrapper_js_1 = require("../Wrapper.js");
const mspace_js_1 = require("../../common/Wrappers/mspace.js");
const mspace_js_2 = require("../../../core/MmlTree/MmlNodes/mspace.js");
class CHTMLmspace extends (0, mspace_js_1.CommonMspaceMixin)(Wrapper_js_1.CHTMLWrapper) {
    toCHTML(parent) {
        let chtml = this.standardCHTMLnode(parent);
        let { w, h, d } = this.getBBox();
        if (w < 0) {
            this.adaptor.setStyle(chtml, 'marginRight', this.em(w));
            w = 0;
        }
        if (w) {
            this.adaptor.setStyle(chtml, 'width', this.em(w));
        }
        h = Math.max(0, h + d);
        if (h) {
            this.adaptor.setStyle(chtml, 'height', this.em(Math.max(0, h)));
        }
        if (d) {
            this.adaptor.setStyle(chtml, 'verticalAlign', this.em(-d));
        }
    }
}
exports.CHTMLmspace = CHTMLmspace;
CHTMLmspace.kind = mspace_js_2.MmlMspace.prototype.kind;
//# sourceMappingURL=mspace.js.map