"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.CHTMLmsqrt = void 0;
const Wrapper_js_1 = require("../Wrapper.js");
const msqrt_js_1 = require("../../common/Wrappers/msqrt.js");
const msqrt_js_2 = require("../../../core/MmlTree/MmlNodes/msqrt.js");
class CHTMLmsqrt extends (0, msqrt_js_1.CommonMsqrtMixin)(Wrapper_js_1.CHTMLWrapper) {
    toCHTML(parent) {
        const surd = this.childNodes[this.surd];
        const base = this.childNodes[this.base];
        const sbox = surd.getBBox();
        const bbox = base.getOuterBBox();
        const [, q] = this.getPQ(sbox);
        const t = this.font.params.rule_thickness;
        const H = bbox.h + q + t;
        const CHTML = this.standardCHTMLnode(parent);
        let SURD, BASE, ROOT, root;
        if (this.root != null) {
            ROOT = this.adaptor.append(CHTML, this.html('mjx-root'));
            root = this.childNodes[this.root];
        }
        const SQRT = this.adaptor.append(CHTML, this.html('mjx-sqrt', {}, [
            SURD = this.html('mjx-surd'),
            BASE = this.html('mjx-box', { style: { paddingTop: this.em(q) } })
        ]));
        this.addRoot(ROOT, root, sbox, H);
        surd.toCHTML(SURD);
        base.toCHTML(BASE);
        if (surd.size < 0) {
            this.adaptor.addClass(SQRT, 'mjx-tall');
        }
    }
    addRoot(_ROOT, _root, _sbox, _H) {
    }
}
exports.CHTMLmsqrt = CHTMLmsqrt;
CHTMLmsqrt.kind = msqrt_js_2.MmlMsqrt.prototype.kind;
CHTMLmsqrt.styles = {
    'mjx-root': {
        display: 'inline-block',
        'white-space': 'nowrap'
    },
    'mjx-surd': {
        display: 'inline-block',
        'vertical-align': 'top'
    },
    'mjx-sqrt': {
        display: 'inline-block',
        'padding-top': '.07em'
    },
    'mjx-sqrt > mjx-box': {
        'border-top': '.07em solid'
    },
    'mjx-sqrt.mjx-tall > mjx-box': {
        'padding-left': '.3em',
        'margin-left': '-.3em'
    }
};
//# sourceMappingURL=msqrt.js.map