"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.CHTMLmsubsup = exports.CHTMLmsup = exports.CHTMLmsub = void 0;
const scriptbase_js_1 = require("./scriptbase.js");
const msubsup_js_1 = require("../../common/Wrappers/msubsup.js");
const msubsup_js_2 = require("../../common/Wrappers/msubsup.js");
const msubsup_js_3 = require("../../common/Wrappers/msubsup.js");
const msubsup_js_4 = require("../../../core/MmlTree/MmlNodes/msubsup.js");
class CHTMLmsub extends (0, msubsup_js_1.CommonMsubMixin)(scriptbase_js_1.CHTMLscriptbase) {
}
exports.CHTMLmsub = CHTMLmsub;
CHTMLmsub.kind = msubsup_js_4.MmlMsub.prototype.kind;
class CHTMLmsup extends (0, msubsup_js_2.CommonMsupMixin)(scriptbase_js_1.CHTMLscriptbase) {
}
exports.CHTMLmsup = CHTMLmsup;
CHTMLmsup.kind = msubsup_js_4.MmlMsup.prototype.kind;
class CHTMLmsubsup extends (0, msubsup_js_3.CommonMsubsupMixin)(scriptbase_js_1.CHTMLscriptbase) {
    toCHTML(parent) {
        const adaptor = this.adaptor;
        const chtml = this.standardCHTMLnode(parent);
        const [base, sup, sub] = [this.baseChild, this.supChild, this.subChild];
        const [, v, q] = this.getUVQ();
        const style = { 'vertical-align': this.em(v) };
        base.toCHTML(chtml);
        const stack = adaptor.append(chtml, this.html('mjx-script', { style }));
        sup.toCHTML(stack);
        adaptor.append(stack, this.html('mjx-spacer', { style: { 'margin-top': this.em(q) } }));
        sub.toCHTML(stack);
        const ic = this.getAdjustedIc();
        if (ic) {
            adaptor.setStyle(sup.chtml, 'marginLeft', this.em(ic / sup.bbox.rscale));
        }
        if (this.baseRemoveIc) {
            adaptor.setStyle(stack, 'marginLeft', this.em(-this.baseIc));
        }
    }
}
exports.CHTMLmsubsup = CHTMLmsubsup;
CHTMLmsubsup.kind = msubsup_js_4.MmlMsubsup.prototype.kind;
CHTMLmsubsup.styles = {
    'mjx-script': {
        display: 'inline-block',
        'padding-right': '.05em',
        'padding-left': '.033em'
    },
    'mjx-script > mjx-spacer': {
        display: 'block'
    }
};
//# sourceMappingURL=msubsup.js.map