"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.CHTMLmlabeledtr = exports.CHTMLmtr = void 0;
const Wrapper_js_1 = require("../Wrapper.js");
const mtr_js_1 = require("../../common/Wrappers/mtr.js");
const mtr_js_2 = require("../../common/Wrappers/mtr.js");
const mtr_js_3 = require("../../../core/MmlTree/MmlNodes/mtr.js");
class CHTMLmtr extends (0, mtr_js_1.CommonMtrMixin)(Wrapper_js_1.CHTMLWrapper) {
    toCHTML(parent) {
        super.toCHTML(parent);
        const align = this.node.attributes.get('rowalign');
        if (align !== 'baseline') {
            this.adaptor.setAttribute(this.chtml, 'rowalign', align);
        }
    }
}
exports.CHTMLmtr = CHTMLmtr;
CHTMLmtr.kind = mtr_js_3.MmlMtr.prototype.kind;
CHTMLmtr.styles = {
    'mjx-mtr': {
        display: 'table-row',
    },
    'mjx-mtr[rowalign="top"] > mjx-mtd': {
        'vertical-align': 'top'
    },
    'mjx-mtr[rowalign="center"] > mjx-mtd': {
        'vertical-align': 'middle'
    },
    'mjx-mtr[rowalign="bottom"] > mjx-mtd': {
        'vertical-align': 'bottom'
    },
    'mjx-mtr[rowalign="baseline"] > mjx-mtd': {
        'vertical-align': 'baseline'
    },
    'mjx-mtr[rowalign="axis"] > mjx-mtd': {
        'vertical-align': '.25em'
    }
};
class CHTMLmlabeledtr extends (0, mtr_js_2.CommonMlabeledtrMixin)(CHTMLmtr) {
    toCHTML(parent) {
        super.toCHTML(parent);
        const child = this.adaptor.firstChild(this.chtml);
        if (child) {
            this.adaptor.remove(child);
            const align = this.node.attributes.get('rowalign');
            const attr = (align !== 'baseline' && align !== 'axis' ? { rowalign: align } : {});
            const row = this.html('mjx-mtr', attr, [child]);
            this.adaptor.append(this.parent.labels, row);
        }
    }
    markUsed() {
        super.markUsed();
        this.jax.wrapperUsage.add(CHTMLmtr.kind);
    }
}
exports.CHTMLmlabeledtr = CHTMLmlabeledtr;
CHTMLmlabeledtr.kind = mtr_js_3.MmlMlabeledtr.prototype.kind;
CHTMLmlabeledtr.styles = {
    'mjx-mlabeledtr': {
        display: 'table-row'
    },
    'mjx-mlabeledtr[rowalign="top"] > mjx-mtd': {
        'vertical-align': 'top'
    },
    'mjx-mlabeledtr[rowalign="center"] > mjx-mtd': {
        'vertical-align': 'middle'
    },
    'mjx-mlabeledtr[rowalign="bottom"] > mjx-mtd': {
        'vertical-align': 'bottom'
    },
    'mjx-mlabeledtr[rowalign="baseline"] > mjx-mtd': {
        'vertical-align': 'baseline'
    },
    'mjx-mlabeledtr[rowalign="axis"] > mjx-mtd': {
        'vertical-align': '.25em'
    }
};
//# sourceMappingURL=mtr.js.map