"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.CHTMLmunderover = exports.CHTMLmover = exports.CHTMLmunder = void 0;
const msubsup_js_1 = require("./msubsup.js");
const munderover_js_1 = require("../../common/Wrappers/munderover.js");
const munderover_js_2 = require("../../common/Wrappers/munderover.js");
const munderover_js_3 = require("../../common/Wrappers/munderover.js");
const munderover_js_4 = require("../../../core/MmlTree/MmlNodes/munderover.js");
class CHTMLmunder extends (0, munderover_js_1.CommonMunderMixin)(msubsup_js_1.CHTMLmsub) {
    toCHTML(parent) {
        if (this.hasMovableLimits()) {
            super.toCHTML(parent);
            this.adaptor.setAttribute(this.chtml, 'limits', 'false');
            return;
        }
        this.chtml = this.standardCHTMLnode(parent);
        const base = this.adaptor.append(this.adaptor.append(this.chtml, this.html('mjx-row')), this.html('mjx-base'));
        const under = this.adaptor.append(this.adaptor.append(this.chtml, this.html('mjx-row')), this.html('mjx-under'));
        this.baseChild.toCHTML(base);
        this.scriptChild.toCHTML(under);
        const basebox = this.baseChild.getOuterBBox();
        const underbox = this.scriptChild.getOuterBBox();
        const k = this.getUnderKV(basebox, underbox)[0];
        const delta = (this.isLineBelow ? 0 : this.getDelta(true));
        this.adaptor.setStyle(under, 'paddingTop', this.em(k));
        this.setDeltaW([base, under], this.getDeltaW([basebox, underbox], [0, -delta]));
        this.adjustUnderDepth(under, underbox);
    }
}
exports.CHTMLmunder = CHTMLmunder;
CHTMLmunder.kind = munderover_js_4.MmlMunder.prototype.kind;
CHTMLmunder.styles = {
    'mjx-over': {
        'text-align': 'left'
    },
    'mjx-munder:not([limits="false"])': {
        display: 'inline-table',
    },
    'mjx-munder > mjx-row': {
        'text-align': 'left'
    },
    'mjx-under': {
        'padding-bottom': '.1em'
    }
};
class CHTMLmover extends (0, munderover_js_2.CommonMoverMixin)(msubsup_js_1.CHTMLmsup) {
    toCHTML(parent) {
        if (this.hasMovableLimits()) {
            super.toCHTML(parent);
            this.adaptor.setAttribute(this.chtml, 'limits', 'false');
            return;
        }
        this.chtml = this.standardCHTMLnode(parent);
        const over = this.adaptor.append(this.chtml, this.html('mjx-over'));
        const base = this.adaptor.append(this.chtml, this.html('mjx-base'));
        this.scriptChild.toCHTML(over);
        this.baseChild.toCHTML(base);
        const overbox = this.scriptChild.getOuterBBox();
        const basebox = this.baseChild.getOuterBBox();
        this.adjustBaseHeight(base, basebox);
        const k = this.getOverKU(basebox, overbox)[0];
        const delta = (this.isLineAbove ? 0 : this.getDelta());
        this.adaptor.setStyle(over, 'paddingBottom', this.em(k));
        this.setDeltaW([base, over], this.getDeltaW([basebox, overbox], [0, delta]));
        this.adjustOverDepth(over, overbox);
    }
}
exports.CHTMLmover = CHTMLmover;
CHTMLmover.kind = munderover_js_4.MmlMover.prototype.kind;
CHTMLmover.styles = {
    'mjx-mover:not([limits="false"])': {
        'padding-top': '.1em'
    },
    'mjx-mover:not([limits="false"]) > *': {
        display: 'block',
        'text-align': 'left'
    }
};
class CHTMLmunderover extends (0, munderover_js_3.CommonMunderoverMixin)(msubsup_js_1.CHTMLmsubsup) {
    toCHTML(parent) {
        if (this.hasMovableLimits()) {
            super.toCHTML(parent);
            this.adaptor.setAttribute(this.chtml, 'limits', 'false');
            return;
        }
        this.chtml = this.standardCHTMLnode(parent);
        const over = this.adaptor.append(this.chtml, this.html('mjx-over'));
        const table = this.adaptor.append(this.adaptor.append(this.chtml, this.html('mjx-box')), this.html('mjx-munder'));
        const base = this.adaptor.append(this.adaptor.append(table, this.html('mjx-row')), this.html('mjx-base'));
        const under = this.adaptor.append(this.adaptor.append(table, this.html('mjx-row')), this.html('mjx-under'));
        this.overChild.toCHTML(over);
        this.baseChild.toCHTML(base);
        this.underChild.toCHTML(under);
        const overbox = this.overChild.getOuterBBox();
        const basebox = this.baseChild.getOuterBBox();
        const underbox = this.underChild.getOuterBBox();
        this.adjustBaseHeight(base, basebox);
        const ok = this.getOverKU(basebox, overbox)[0];
        const uk = this.getUnderKV(basebox, underbox)[0];
        const delta = this.getDelta();
        this.adaptor.setStyle(over, 'paddingBottom', this.em(ok));
        this.adaptor.setStyle(under, 'paddingTop', this.em(uk));
        this.setDeltaW([base, under, over], this.getDeltaW([basebox, underbox, overbox], [0, this.isLineBelow ? 0 : -delta, this.isLineAbove ? 0 : delta]));
        this.adjustOverDepth(over, overbox);
        this.adjustUnderDepth(under, underbox);
    }
    markUsed() {
        super.markUsed();
        this.jax.wrapperUsage.add(msubsup_js_1.CHTMLmsubsup.kind);
    }
}
exports.CHTMLmunderover = CHTMLmunderover;
CHTMLmunderover.kind = munderover_js_4.MmlMunderover.prototype.kind;
CHTMLmunderover.styles = {
    'mjx-munderover:not([limits="false"])': {
        'padding-top': '.1em'
    },
    'mjx-munderover:not([limits="false"]) > *': {
        display: 'block'
    },
};
//# sourceMappingURL=munderover.js.map