"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.CHTMLscriptbase = void 0;
const Wrapper_js_1 = require("../Wrapper.js");
const scriptbase_js_1 = require("../../common/Wrappers/scriptbase.js");
class CHTMLscriptbase extends (0, scriptbase_js_1.CommonScriptbaseMixin)(Wrapper_js_1.CHTMLWrapper) {
    toCHTML(parent) {
        this.chtml = this.standardCHTMLnode(parent);
        const [x, v] = this.getOffset();
        const dx = x - (this.baseRemoveIc ? this.baseIc : 0);
        const style = { 'vertical-align': this.em(v) };
        if (dx) {
            style['margin-left'] = this.em(dx);
        }
        this.baseChild.toCHTML(this.chtml);
        this.scriptChild.toCHTML(this.adaptor.append(this.chtml, this.html('mjx-script', { style })));
    }
    setDeltaW(nodes, dx) {
        for (let i = 0; i < dx.length; i++) {
            if (dx[i]) {
                this.adaptor.setStyle(nodes[i], 'paddingLeft', this.em(dx[i]));
            }
        }
    }
    adjustOverDepth(over, overbox) {
        if (overbox.d >= 0)
            return;
        this.adaptor.setStyle(over, 'marginBottom', this.em(overbox.d * overbox.rscale));
    }
    adjustUnderDepth(under, underbox) {
        if (underbox.d >= 0)
            return;
        const adaptor = this.adaptor;
        const v = this.em(underbox.d);
        const box = this.html('mjx-box', { style: { 'margin-bottom': v, 'vertical-align': v } });
        for (const child of adaptor.childNodes(adaptor.firstChild(under))) {
            adaptor.append(box, child);
        }
        adaptor.append(adaptor.firstChild(under), box);
    }
    adjustBaseHeight(base, basebox) {
        if (this.node.attributes.get('accent')) {
            const minH = this.font.params.x_height * basebox.scale;
            if (basebox.h < minH) {
                this.adaptor.setStyle(base, 'paddingTop', this.em(minH - basebox.h));
                basebox.h = minH;
            }
        }
    }
}
exports.CHTMLscriptbase = CHTMLscriptbase;
CHTMLscriptbase.kind = 'scriptbase';
//# sourceMappingURL=scriptbase.js.map