"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.CHTMLxml = exports.CHTMLannotationXML = exports.CHTMLannotation = exports.CHTMLsemantics = void 0;
const Wrapper_js_1 = require("../Wrapper.js");
const semantics_js_1 = require("../../common/Wrappers/semantics.js");
const semantics_js_2 = require("../../../core/MmlTree/MmlNodes/semantics.js");
const MmlNode_js_1 = require("../../../core/MmlTree/MmlNode.js");
class CHTMLsemantics extends (0, semantics_js_1.CommonSemanticsMixin)(Wrapper_js_1.CHTMLWrapper) {
    toCHTML(parent) {
        const chtml = this.standardCHTMLnode(parent);
        if (this.childNodes.length) {
            this.childNodes[0].toCHTML(chtml);
        }
    }
}
exports.CHTMLsemantics = CHTMLsemantics;
CHTMLsemantics.kind = semantics_js_2.MmlSemantics.prototype.kind;
class CHTMLannotation extends Wrapper_js_1.CHTMLWrapper {
    toCHTML(parent) {
        super.toCHTML(parent);
    }
    computeBBox() {
        return this.bbox;
    }
}
exports.CHTMLannotation = CHTMLannotation;
CHTMLannotation.kind = semantics_js_2.MmlAnnotation.prototype.kind;
class CHTMLannotationXML extends Wrapper_js_1.CHTMLWrapper {
}
exports.CHTMLannotationXML = CHTMLannotationXML;
CHTMLannotationXML.kind = semantics_js_2.MmlAnnotationXML.prototype.kind;
CHTMLannotationXML.styles = {
    'mjx-annotation-xml': {
        'font-family': 'initial',
        'line-height': 'normal'
    }
};
class CHTMLxml extends Wrapper_js_1.CHTMLWrapper {
    toCHTML(parent) {
        this.chtml = this.adaptor.append(parent, this.adaptor.clone(this.node.getXML()));
    }
    computeBBox(bbox, _recompute = false) {
        const { w, h, d } = this.jax.measureXMLnode(this.node.getXML());
        bbox.w = w;
        bbox.h = h;
        bbox.d = d;
    }
    getStyles() { }
    getScale() { }
    getVariant() { }
}
exports.CHTMLxml = CHTMLxml;
CHTMLxml.kind = MmlNode_js_1.XMLNode.prototype.kind;
CHTMLxml.autoStyle = false;
//# sourceMappingURL=semantics.js.map