"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.CommonMfencedMixin = void 0;
function CommonMfencedMixin(Base) {
    return class extends Base {
        constructor(...args) {
            super(...args);
            this.mrow = null;
            this.createMrow();
            this.addMrowChildren();
        }
        createMrow() {
            const mmlFactory = this.node.factory;
            const mrow = mmlFactory.create('inferredMrow');
            mrow.inheritAttributesFrom(this.node);
            this.mrow = this.wrap(mrow);
            this.mrow.parent = this;
        }
        addMrowChildren() {
            const mfenced = this.node;
            const mrow = this.mrow;
            this.addMo(mfenced.open);
            if (this.childNodes.length) {
                mrow.childNodes.push(this.childNodes[0]);
            }
            let i = 0;
            for (const child of this.childNodes.slice(1)) {
                this.addMo(mfenced.separators[i++]);
                mrow.childNodes.push(child);
            }
            this.addMo(mfenced.close);
            mrow.stretchChildren();
        }
        addMo(node) {
            if (!node)
                return;
            const mo = this.wrap(node);
            this.mrow.childNodes.push(mo);
            mo.parent = this.mrow;
        }
        computeBBox(bbox, recompute = false) {
            bbox.updateFrom(this.mrow.getOuterBBox());
            this.setChildPWidths(recompute);
        }
    };
}
exports.CommonMfencedMixin = CommonMfencedMixin;
//# sourceMappingURL=mfenced.js.map