"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.CommonInferredMrowMixin = exports.CommonMrowMixin = void 0;
const BBox_js_1 = require("../../../util/BBox.js");
function CommonMrowMixin(Base) {
    return class extends Base {
        get fixesPWidth() {
            return false;
        }
        constructor(...args) {
            super(...args);
            this.stretchChildren();
            for (const child of this.childNodes) {
                if (child.bbox.pwidth) {
                    this.bbox.pwidth = BBox_js_1.BBox.fullWidth;
                    break;
                }
            }
        }
        stretchChildren() {
            let stretchy = [];
            for (const child of this.childNodes) {
                if (child.canStretch(1)) {
                    stretchy.push(child);
                }
            }
            let count = stretchy.length;
            let nodeCount = this.childNodes.length;
            if (count && nodeCount > 1) {
                let H = 0, D = 0;
                let all = (count > 1 && count === nodeCount);
                for (const child of this.childNodes) {
                    const noStretch = (child.stretch.dir === 0);
                    if (all || noStretch) {
                        let { h, d, rscale } = child.getOuterBBox(noStretch);
                        h *= rscale;
                        d *= rscale;
                        if (h > H)
                            H = h;
                        if (d > D)
                            D = d;
                    }
                }
                for (const child of stretchy) {
                    child.coreMO().getStretchedVariant([H, D]);
                }
            }
        }
    };
}
exports.CommonMrowMixin = CommonMrowMixin;
function CommonInferredMrowMixin(Base) {
    return class extends Base {
        getScale() {
            this.bbox.scale = this.parent.bbox.scale;
            this.bbox.rscale = 1;
        }
    };
}
exports.CommonInferredMrowMixin = CommonInferredMrowMixin;
//# sourceMappingURL=mrow.js.map