"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.CommonMsqrtMixin = void 0;
const BBox_js_1 = require("../../../util/BBox.js");
function CommonMsqrtMixin(Base) {
    return class extends Base {
        get base() {
            return 0;
        }
        get surd() {
            return 1;
        }
        get root() {
            return null;
        }
        constructor(...args) {
            super(...args);
            const surd = this.createMo('\u221A');
            surd.canStretch(1);
            const { h, d } = this.childNodes[this.base].getOuterBBox();
            const t = this.font.params.rule_thickness;
            const p = (this.node.attributes.get('displaystyle') ? this.font.params.x_height : t);
            this.surdH = h + d + 2 * t + p / 4;
            surd.getStretchedVariant([this.surdH - d, d], true);
        }
        createMo(text) {
            const node = super.createMo(text);
            this.childNodes.push(node);
            return node;
        }
        computeBBox(bbox, recompute = false) {
            const surdbox = this.childNodes[this.surd].getBBox();
            const basebox = new BBox_js_1.BBox(this.childNodes[this.base].getOuterBBox());
            const q = this.getPQ(surdbox)[1];
            const t = this.font.params.rule_thickness;
            const H = basebox.h + q + t;
            const [x] = this.getRootDimens(surdbox, H);
            bbox.h = H + t;
            this.combineRootBBox(bbox, surdbox, H);
            bbox.combine(surdbox, x, H - surdbox.h);
            bbox.combine(basebox, x + surdbox.w, 0);
            bbox.clean();
            this.setChildPWidths(recompute);
        }
        combineRootBBox(_bbox, _sbox, _H) {
        }
        getPQ(sbox) {
            const t = this.font.params.rule_thickness;
            const p = (this.node.attributes.get('displaystyle') ? this.font.params.x_height : t);
            const q = (sbox.h + sbox.d > this.surdH ?
                ((sbox.h + sbox.d) - (this.surdH - 2 * t - p / 2)) / 2 :
                t + p / 4);
            return [p, q];
        }
        getRootDimens(_sbox, _H) {
            return [0, 0, 0, 0];
        }
    };
}
exports.CommonMsqrtMixin = CommonMsqrtMixin;
//# sourceMappingURL=msqrt.js.map