"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.CommonMsubsupMixin = exports.CommonMsupMixin = exports.CommonMsubMixin = void 0;
function CommonMsubMixin(Base) {
    var _a;
    return _a = class extends Base {
            get scriptChild() {
                return this.childNodes[this.node.sub];
            }
            getOffset() {
                return [0, -this.getV()];
            }
        },
        _a.useIC = false,
        _a;
}
exports.CommonMsubMixin = CommonMsubMixin;
function CommonMsupMixin(Base) {
    return class extends Base {
        get scriptChild() {
            return this.childNodes[this.node.sup];
        }
        getOffset() {
            const x = this.getAdjustedIc() - (this.baseRemoveIc ? 0 : this.baseIc);
            return [x, this.getU()];
        }
    };
}
exports.CommonMsupMixin = CommonMsupMixin;
function CommonMsubsupMixin(Base) {
    var _a;
    return _a = class extends Base {
            constructor() {
                super(...arguments);
                this.UVQ = null;
            }
            get subChild() {
                return this.childNodes[this.node.sub];
            }
            get supChild() {
                return this.childNodes[this.node.sup];
            }
            computeBBox(bbox, recompute = false) {
                const basebox = this.baseChild.getOuterBBox();
                const [subbox, supbox] = [this.subChild.getOuterBBox(), this.supChild.getOuterBBox()];
                bbox.empty();
                bbox.append(basebox);
                const w = this.getBaseWidth();
                const x = this.getAdjustedIc();
                const [u, v] = this.getUVQ();
                bbox.combine(subbox, w, v);
                bbox.combine(supbox, w + x, u);
                bbox.w += this.font.params.scriptspace;
                bbox.clean();
                this.setChildPWidths(recompute);
            }
            getUVQ(subbox = this.subChild.getOuterBBox(), supbox = this.supChild.getOuterBBox()) {
                const basebox = this.baseCore.getOuterBBox();
                if (this.UVQ)
                    return this.UVQ;
                const tex = this.font.params;
                const t = 3 * tex.rule_thickness;
                const subscriptshift = this.length2em(this.node.attributes.get('subscriptshift'), tex.sub2);
                const drop = this.baseCharZero(basebox.d * this.baseScale + tex.sub_drop * subbox.rscale);
                let [u, v] = [this.getU(), Math.max(drop, subscriptshift)];
                let q = (u - supbox.d * supbox.rscale) - (subbox.h * subbox.rscale - v);
                if (q < t) {
                    v += t - q;
                    const p = (4 / 5) * tex.x_height - (u - supbox.d * supbox.rscale);
                    if (p > 0) {
                        u += p;
                        v -= p;
                    }
                }
                u = Math.max(this.length2em(this.node.attributes.get('superscriptshift'), u), u);
                v = Math.max(this.length2em(this.node.attributes.get('subscriptshift'), v), v);
                q = (u - supbox.d * supbox.rscale) - (subbox.h * subbox.rscale - v);
                this.UVQ = [u, -v, q];
                return this.UVQ;
            }
        },
        _a.useIC = false,
        _a;
}
exports.CommonMsubsupMixin = CommonMsubsupMixin;
//# sourceMappingURL=msubsup.js.map