import { CharMap, CharOptions, CharData, VariantData, DelimiterData, FontData } from '../common/FontData.js';
export * from '../common/FontData.js';
export type CharStringMap = {
    [name: number]: string;
};
export interface SVGCharOptions extends CharOptions {
    c?: string;
    p?: string;
}
export type SVGCharMap = CharMap<SVGCharOptions>;
export type SVGCharData = CharData<SVGCharOptions>;
export interface SVGVariantData extends VariantData<SVGCharOptions> {
    cacheID: string;
}
export interface SVGDelimiterData extends DelimiterData {
}
export declare class SVGFontData extends FontData<SVGCharOptions, SVGVariantData, SVGDelimiterData> {
    static OPTIONS: {
        dynamicPrefix: string;
    };
    static JAX: string;
    static charOptions(font: SVGCharMap, n: number): SVGCharOptions;
}
export type SVGFontDataClass = typeof SVGFontData;
export declare function AddPaths(font: SVGCharMap, paths: CharStringMap, content: CharStringMap): SVGCharMap;
