"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.SVGWrappers = void 0;
const Wrapper_js_1 = require("./Wrapper.js");
const math_js_1 = require("./Wrappers/math.js");
const mrow_js_1 = require("./Wrappers/mrow.js");
const mi_js_1 = require("./Wrappers/mi.js");
const mo_js_1 = require("./Wrappers/mo.js");
const mn_js_1 = require("./Wrappers/mn.js");
const ms_js_1 = require("./Wrappers/ms.js");
const mtext_js_1 = require("./Wrappers/mtext.js");
const merror_js_1 = require("./Wrappers/merror.js");
const mspace_js_1 = require("./Wrappers/mspace.js");
const mpadded_js_1 = require("./Wrappers/mpadded.js");
const mphantom_js_1 = require("./Wrappers/mphantom.js");
const mfrac_js_1 = require("./Wrappers/mfrac.js");
const msqrt_js_1 = require("./Wrappers/msqrt.js");
const mroot_js_1 = require("./Wrappers/mroot.js");
const mfenced_js_1 = require("./Wrappers/mfenced.js");
const msubsup_js_1 = require("./Wrappers/msubsup.js");
const munderover_js_1 = require("./Wrappers/munderover.js");
const mmultiscripts_js_1 = require("./Wrappers/mmultiscripts.js");
const mtable_js_1 = require("./Wrappers/mtable.js");
const mtr_js_1 = require("./Wrappers/mtr.js");
const mtd_js_1 = require("./Wrappers/mtd.js");
const maction_js_1 = require("./Wrappers/maction.js");
const menclose_js_1 = require("./Wrappers/menclose.js");
const semantics_js_1 = require("./Wrappers/semantics.js");
const mglyph_js_1 = require("./Wrappers/mglyph.js");
const TeXAtom_js_1 = require("./Wrappers/TeXAtom.js");
const TextNode_js_1 = require("./Wrappers/TextNode.js");
exports.SVGWrappers = {
    [math_js_1.SVGmath.kind]: math_js_1.SVGmath,
    [mrow_js_1.SVGmrow.kind]: mrow_js_1.SVGmrow,
    [mrow_js_1.SVGinferredMrow.kind]: mrow_js_1.SVGinferredMrow,
    [mi_js_1.SVGmi.kind]: mi_js_1.SVGmi,
    [mo_js_1.SVGmo.kind]: mo_js_1.SVGmo,
    [mn_js_1.SVGmn.kind]: mn_js_1.SVGmn,
    [ms_js_1.SVGms.kind]: ms_js_1.SVGms,
    [mtext_js_1.SVGmtext.kind]: mtext_js_1.SVGmtext,
    [merror_js_1.SVGmerror.kind]: merror_js_1.SVGmerror,
    [mspace_js_1.SVGmspace.kind]: mspace_js_1.SVGmspace,
    [mpadded_js_1.SVGmpadded.kind]: mpadded_js_1.SVGmpadded,
    [mphantom_js_1.SVGmphantom.kind]: mphantom_js_1.SVGmphantom,
    [mfrac_js_1.SVGmfrac.kind]: mfrac_js_1.SVGmfrac,
    [msqrt_js_1.SVGmsqrt.kind]: msqrt_js_1.SVGmsqrt,
    [mroot_js_1.SVGmroot.kind]: mroot_js_1.SVGmroot,
    [mfenced_js_1.SVGmfenced.kind]: mfenced_js_1.SVGmfenced,
    [msubsup_js_1.SVGmsub.kind]: msubsup_js_1.SVGmsub,
    [msubsup_js_1.SVGmsup.kind]: msubsup_js_1.SVGmsup,
    [msubsup_js_1.SVGmsubsup.kind]: msubsup_js_1.SVGmsubsup,
    [munderover_js_1.SVGmunder.kind]: munderover_js_1.SVGmunder,
    [munderover_js_1.SVGmover.kind]: munderover_js_1.SVGmover,
    [munderover_js_1.SVGmunderover.kind]: munderover_js_1.SVGmunderover,
    [mmultiscripts_js_1.SVGmmultiscripts.kind]: mmultiscripts_js_1.SVGmmultiscripts,
    [mtable_js_1.SVGmtable.kind]: mtable_js_1.SVGmtable,
    [mtr_js_1.SVGmtr.kind]: mtr_js_1.SVGmtr,
    [mtr_js_1.SVGmlabeledtr.kind]: mtr_js_1.SVGmlabeledtr,
    [mtd_js_1.SVGmtd.kind]: mtd_js_1.SVGmtd,
    [maction_js_1.SVGmaction.kind]: maction_js_1.SVGmaction,
    [menclose_js_1.SVGmenclose.kind]: menclose_js_1.SVGmenclose,
    [semantics_js_1.SVGsemantics.kind]: semantics_js_1.SVGsemantics,
    [semantics_js_1.SVGannotation.kind]: semantics_js_1.SVGannotation,
    [semantics_js_1.SVGannotationXML.kind]: semantics_js_1.SVGannotationXML,
    [semantics_js_1.SVGxml.kind]: semantics_js_1.SVGxml,
    [mglyph_js_1.SVGmglyph.kind]: mglyph_js_1.SVGmglyph,
    [TeXAtom_js_1.SVGTeXAtom.kind]: TeXAtom_js_1.SVGTeXAtom,
    [TextNode_js_1.SVGTextNode.kind]: TextNode_js_1.SVGTextNode,
    [Wrapper_js_1.SVGWrapper.kind]: Wrapper_js_1.SVGWrapper
};
//# sourceMappingURL=Wrappers.js.map