"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.SVGTeXAtom = void 0;
const Wrapper_js_1 = require("../Wrapper.js");
const TeXAtom_js_1 = require("../../common/Wrappers/TeXAtom.js");
const TeXAtom_js_2 = require("../../../core/MmlTree/MmlNodes/TeXAtom.js");
const MmlNode_js_1 = require("../../../core/MmlTree/MmlNode.js");
class SVGTeXAtom extends (0, TeXAtom_js_1.CommonTeXAtomMixin)(Wrapper_js_1.SVGWrapper) {
    toSVG(parent) {
        super.toSVG(parent);
        this.adaptor.setAttribute(this.element, 'data-mjx-texclass', MmlNode_js_1.TEXCLASSNAMES[this.node.texClass]);
        if (this.node.texClass === MmlNode_js_1.TEXCLASS.VCENTER) {
            const bbox = this.childNodes[0].getBBox();
            const { h, d } = bbox;
            const a = this.font.params.axis_height;
            const dh = ((h + d) / 2 + a) - h;
            const translate = 'translate(0 ' + this.fixed(dh) + ')';
            this.adaptor.setAttribute(this.element, 'transform', translate);
        }
    }
}
exports.SVGTeXAtom = SVGTeXAtom;
SVGTeXAtom.kind = TeXAtom_js_2.TeXAtom.prototype.kind;
//# sourceMappingURL=TeXAtom.js.map