"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.SVGTextNode = void 0;
const MmlNode_js_1 = require("../../../core/MmlTree/MmlNode.js");
const Wrapper_js_1 = require("../Wrapper.js");
const TextNode_js_1 = require("../../common/Wrappers/TextNode.js");
class SVGTextNode extends (0, TextNode_js_1.CommonTextNodeMixin)(Wrapper_js_1.SVGWrapper) {
    toSVG(parent) {
        const text = this.node.getText();
        const variant = this.parent.variant;
        if (text.length === 0)
            return;
        if (variant === '-explicitFont') {
            this.element = this.adaptor.append(parent, this.jax.unknownText(text, variant));
        }
        else {
            const chars = this.remappedText(text, variant);
            if (this.parent.childNodes.length > 1) {
                parent = this.element = this.adaptor.append(parent, this.svg('g', { 'data-mml-node': 'text' }));
            }
            let x = 0;
            for (const n of chars) {
                x += this.placeChar(n, x, 0, parent, variant);
            }
        }
    }
}
exports.SVGTextNode = SVGTextNode;
SVGTextNode.kind = MmlNode_js_1.TextNode.prototype.kind;
SVGTextNode.styles = {
    'mjx-container[jax="SVG"] path[data-c], mjx-container[jax="SVG"] use[data-c]': {
        'stroke-width': 3
    }
};
//# sourceMappingURL=TextNode.js.map