"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.SVGmerror = void 0;
const Wrapper_js_1 = require("../Wrapper.js");
const merror_js_1 = require("../../../core/MmlTree/MmlNodes/merror.js");
class SVGmerror extends Wrapper_js_1.SVGWrapper {
    toSVG(parent) {
        const svg = this.standardSVGnode(parent);
        const { h, d, w } = this.getBBox();
        this.adaptor.append(this.element, this.svg('rect', {
            'data-background': true,
            width: this.fixed(w), height: this.fixed(h + d), y: this.fixed(-d)
        }));
        const title = this.node.attributes.get('title');
        if (title) {
            this.adaptor.append(this.element, this.svg('title', {}, [this.adaptor.text(title)]));
        }
        this.addChildren(svg);
    }
}
exports.SVGmerror = SVGmerror;
SVGmerror.kind = merror_js_1.MmlMerror.prototype.kind;
SVGmerror.styles = {
    'g[data-mml-node="merror"] > g': {
        fill: 'red',
        stroke: 'red'
    },
    'g[data-mml-node="merror"] > rect[data-background]': {
        fill: 'yellow',
        stroke: 'none'
    }
};
//# sourceMappingURL=merror.js.map