"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.SVGmglyph = void 0;
const Wrapper_js_1 = require("../Wrapper.js");
const mglyph_js_1 = require("../../common/Wrappers/mglyph.js");
const mglyph_js_2 = require("../../../core/MmlTree/MmlNodes/mglyph.js");
class SVGmglyph extends (0, mglyph_js_1.CommonMglyphMixin)(Wrapper_js_1.SVGWrapper) {
    toSVG(parent) {
        const svg = this.standardSVGnode(parent);
        if (this.charWrapper) {
            this.charWrapper.toSVG(svg);
            return;
        }
        const { src, alt } = this.node.attributes.getList('src', 'alt');
        const h = this.fixed(this.height);
        const w = this.fixed(this.width);
        const y = this.fixed(this.height + (this.valign || 0));
        const properties = {
            width: w, height: h,
            transform: 'translate(0 ' + y + ') matrix(1 0 0 -1 0 0)',
            preserveAspectRatio: 'none',
            'aria-label': alt,
            href: src
        };
        const img = this.svg('image', properties);
        this.adaptor.append(svg, img);
    }
}
exports.SVGmglyph = SVGmglyph;
SVGmglyph.kind = mglyph_js_2.MmlMglyph.prototype.kind;
//# sourceMappingURL=mglyph.js.map