"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.SVGmmultiscripts = exports.AlignX = void 0;
const msubsup_js_1 = require("./msubsup.js");
const mmultiscripts_js_1 = require("../../common/Wrappers/mmultiscripts.js");
const mmultiscripts_js_2 = require("../../../core/MmlTree/MmlNodes/mmultiscripts.js");
const string_js_1 = require("../../../util/string.js");
function AlignX(align) {
    return {
        left: (_w, _W) => 0,
        center: (w, W) => (W - w) / 2,
        right: (w, W) => W - w
    }[align] || ((_w, _W) => 0);
}
exports.AlignX = AlignX;
class SVGmmultiscripts extends (0, mmultiscripts_js_1.CommonMmultiscriptsMixin)(msubsup_js_1.SVGmsubsup) {
    toSVG(parent) {
        const svg = this.standardSVGnode(parent);
        const data = this.scriptData;
        const scriptalign = this.node.getProperty('scriptalign') || 'right left';
        const [preAlign, postAlign] = (0, string_js_1.split)(scriptalign + ' ' + scriptalign);
        const sub = this.combinePrePost(data.sub, data.psub);
        const sup = this.combinePrePost(data.sup, data.psup);
        const [u, v] = this.getUVQ(sub, sup);
        let x = 0;
        if (data.numPrescripts) {
            x = this.addScripts(.05, u, v, this.firstPrescript, data.numPrescripts, preAlign);
        }
        const base = this.baseChild;
        base.toSVG(svg);
        base.place(x, 0);
        x += base.getOuterBBox().w;
        if (data.numScripts) {
            this.addScripts(x, u, v, 1, data.numScripts, postAlign);
        }
    }
    addScripts(x, u, v, i, n, align) {
        const adaptor = this.adaptor;
        const alignX = AlignX(align);
        const supRow = adaptor.append(this.element, this.svg('g'));
        const subRow = adaptor.append(this.element, this.svg('g'));
        this.place(x, u, supRow);
        this.place(x, v, subRow);
        let m = i + 2 * n;
        let dx = 0;
        while (i < m) {
            const [sub, sup] = [this.childNodes[i++], this.childNodes[i++]];
            const [subbox, supbox] = [sub.getOuterBBox(), sup.getOuterBBox()];
            const [subr, supr] = [subbox.rscale, supbox.rscale];
            const w = Math.max(subbox.w * subr, supbox.w * supr);
            sub.toSVG(subRow);
            sup.toSVG(supRow);
            sub.place(dx + alignX(subbox.w * subr, w), 0);
            sup.place(dx + alignX(supbox.w * supr, w), 0);
            dx += w;
        }
        return x + dx;
    }
}
exports.SVGmmultiscripts = SVGmmultiscripts;
SVGmmultiscripts.kind = mmultiscripts_js_2.MmlMmultiscripts.prototype.kind;
//# sourceMappingURL=mmultiscripts.js.map