"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.SVGmpadded = void 0;
const Wrapper_js_1 = require("../Wrapper.js");
const mpadded_js_1 = require("../../common/Wrappers/mpadded.js");
const mpadded_js_2 = require("../../../core/MmlTree/MmlNodes/mpadded.js");
class SVGmpadded extends (0, mpadded_js_1.CommonMpaddedMixin)(Wrapper_js_1.SVGWrapper) {
    toSVG(parent) {
        let svg = this.standardSVGnode(parent);
        const [, , , , , dw, x, y, dx] = this.getDimens();
        const align = this.node.attributes.get('data-align') || 'left';
        const X = x + dx - (dw < 0 && align !== 'left' ? align === 'center' ? dw / 2 : dw : 0);
        if (X || y) {
            svg = this.adaptor.append(svg, this.svg('g'));
            this.place(X, y, svg);
        }
        this.addChildren(svg);
    }
}
exports.SVGmpadded = SVGmpadded;
SVGmpadded.kind = mpadded_js_2.MmlMpadded.prototype.kind;
//# sourceMappingURL=mpadded.js.map