"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.SVGmsqrt = void 0;
const Wrapper_js_1 = require("../Wrapper.js");
const msqrt_js_1 = require("../../common/Wrappers/msqrt.js");
const msqrt_js_2 = require("../../../core/MmlTree/MmlNodes/msqrt.js");
class SVGmsqrt extends (0, msqrt_js_1.CommonMsqrtMixin)(Wrapper_js_1.SVGWrapper) {
    constructor() {
        super(...arguments);
        this.dx = 0;
    }
    toSVG(parent) {
        const surd = this.childNodes[this.surd];
        const base = this.childNodes[this.base];
        const root = (this.root ? this.childNodes[this.root] : null);
        const sbox = surd.getBBox();
        const bbox = base.getOuterBBox();
        const q = this.getPQ(sbox)[1];
        const t = this.font.params.rule_thickness * this.bbox.scale;
        const H = bbox.h + q + t;
        const SVG = this.standardSVGnode(parent);
        const BASE = this.adaptor.append(SVG, this.svg('g'));
        this.addRoot(SVG, root, sbox, H);
        surd.toSVG(SVG);
        surd.place(this.dx, H - sbox.h);
        base.toSVG(BASE);
        base.place(this.dx + sbox.w, 0);
        this.adaptor.append(SVG, this.svg('rect', {
            width: this.fixed(bbox.w), height: this.fixed(t),
            x: this.fixed(this.dx + sbox.w), y: this.fixed(H - t)
        }));
    }
    addRoot(_ROOT, _root, _sbox, _H) {
    }
}
exports.SVGmsqrt = SVGmsqrt;
SVGmsqrt.kind = msqrt_js_2.MmlMsqrt.prototype.kind;
//# sourceMappingURL=msqrt.js.map