"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.SVGmtd = void 0;
const Wrapper_js_1 = require("../Wrapper.js");
const mtd_js_1 = require("../../common/Wrappers/mtd.js");
const mtd_js_2 = require("../../../core/MmlTree/MmlNodes/mtd.js");
class SVGmtd extends (0, mtd_js_1.CommonMtdMixin)(Wrapper_js_1.SVGWrapper) {
    placeCell(x, y, W, H, D) {
        const bbox = this.getBBox();
        const h = Math.max(bbox.h, .75);
        const d = Math.max(bbox.d, .25);
        const calign = this.node.attributes.get('columnalign');
        const ralign = this.node.attributes.get('rowalign');
        const alignX = this.getAlignX(W, bbox, calign);
        const alignY = this.getAlignY(H, D, h, d, ralign);
        this.place(x + alignX, y + alignY);
        return [alignX, alignY];
    }
    placeColor(x, y, W, H) {
        const adaptor = this.adaptor;
        const child = this.firstChild();
        if (child && adaptor.kind(child) === 'rect' && adaptor.getAttribute(child, 'data-bgcolor')) {
            adaptor.setAttribute(child, 'x', this.fixed(x));
            adaptor.setAttribute(child, 'y', this.fixed(y));
            adaptor.setAttribute(child, 'width', this.fixed(W));
            adaptor.setAttribute(child, 'height', this.fixed(H));
        }
    }
}
exports.SVGmtd = SVGmtd;
SVGmtd.kind = mtd_js_2.MmlMtd.prototype.kind;
//# sourceMappingURL=mtd.js.map