"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.SVGmunderover = exports.SVGmover = exports.SVGmunder = void 0;
const msubsup_js_1 = require("./msubsup.js");
const munderover_js_1 = require("../../common/Wrappers/munderover.js");
const munderover_js_2 = require("../../common/Wrappers/munderover.js");
const munderover_js_3 = require("../../common/Wrappers/munderover.js");
const munderover_js_4 = require("../../../core/MmlTree/MmlNodes/munderover.js");
class SVGmunder extends (0, munderover_js_1.CommonMunderMixin)(msubsup_js_1.SVGmsub) {
    toSVG(parent) {
        if (this.hasMovableLimits()) {
            super.toSVG(parent);
            return;
        }
        const svg = this.standardSVGnode(parent);
        const [base, script] = [this.baseChild, this.scriptChild];
        const [bbox, sbox] = [base.getOuterBBox(), script.getOuterBBox()];
        base.toSVG(svg);
        script.toSVG(svg);
        const delta = (this.isLineBelow ? 0 : this.getDelta(true));
        const v = this.getUnderKV(bbox, sbox)[1];
        const [bx, sx] = this.getDeltaW([bbox, sbox], [0, -delta]);
        base.place(bx, 0);
        script.place(sx, v);
    }
}
exports.SVGmunder = SVGmunder;
SVGmunder.kind = munderover_js_4.MmlMunder.prototype.kind;
class SVGmover extends (0, munderover_js_2.CommonMoverMixin)(msubsup_js_1.SVGmsup) {
    toSVG(parent) {
        if (this.hasMovableLimits()) {
            super.toSVG(parent);
            return;
        }
        const svg = this.standardSVGnode(parent);
        const [base, script] = [this.baseChild, this.scriptChild];
        const [bbox, sbox] = [base.getOuterBBox(), script.getOuterBBox()];
        base.toSVG(svg);
        script.toSVG(svg);
        const delta = (this.isLineAbove ? 0 : this.getDelta());
        const u = this.getOverKU(bbox, sbox)[1];
        const [bx, sx] = this.getDeltaW([bbox, sbox], [0, delta]);
        base.place(bx, 0);
        script.place(sx, u);
    }
}
exports.SVGmover = SVGmover;
SVGmover.kind = munderover_js_4.MmlMover.prototype.kind;
class SVGmunderover extends (0, munderover_js_3.CommonMunderoverMixin)(msubsup_js_1.SVGmsubsup) {
    toSVG(parent) {
        if (this.hasMovableLimits()) {
            super.toSVG(parent);
            return;
        }
        const svg = this.standardSVGnode(parent);
        const [base, over, under] = [this.baseChild, this.overChild, this.underChild];
        const [bbox, obox, ubox] = [base.getOuterBBox(), over.getOuterBBox(), under.getOuterBBox()];
        base.toSVG(svg);
        under.toSVG(svg);
        over.toSVG(svg);
        const delta = this.getDelta();
        const u = this.getOverKU(bbox, obox)[1];
        const v = this.getUnderKV(bbox, ubox)[1];
        const [bx, ux, ox] = this.getDeltaW([bbox, ubox, obox], [0, this.isLineBelow ? 0 : -delta, this.isLineAbove ? 0 : delta]);
        base.place(bx, 0);
        under.place(ux, v);
        over.place(ox, u);
    }
}
exports.SVGmunderover = SVGmunderover;
SVGmunderover.kind = munderover_js_4.MmlMunderover.prototype.kind;
//# sourceMappingURL=munderover.js.map