"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.SVGxml = exports.SVGannotationXML = exports.SVGannotation = exports.SVGsemantics = void 0;
const Wrapper_js_1 = require("../Wrapper.js");
const semantics_js_1 = require("../../common/Wrappers/semantics.js");
const semantics_js_2 = require("../../../core/MmlTree/MmlNodes/semantics.js");
const MmlNode_js_1 = require("../../../core/MmlTree/MmlNode.js");
class SVGsemantics extends (0, semantics_js_1.CommonSemanticsMixin)(Wrapper_js_1.SVGWrapper) {
    toSVG(parent) {
        const svg = this.standardSVGnode(parent);
        if (this.childNodes.length) {
            this.childNodes[0].toSVG(svg);
        }
    }
}
exports.SVGsemantics = SVGsemantics;
SVGsemantics.kind = semantics_js_2.MmlSemantics.prototype.kind;
class SVGannotation extends Wrapper_js_1.SVGWrapper {
    toSVG(parent) {
        super.toSVG(parent);
    }
    computeBBox() {
        return this.bbox;
    }
}
exports.SVGannotation = SVGannotation;
SVGannotation.kind = semantics_js_2.MmlAnnotation.prototype.kind;
class SVGannotationXML extends Wrapper_js_1.SVGWrapper {
}
exports.SVGannotationXML = SVGannotationXML;
SVGannotationXML.kind = semantics_js_2.MmlAnnotationXML.prototype.kind;
SVGannotationXML.styles = {
    'foreignObject[data-mjx-xml]': {
        'font-family': 'initial',
        'line-height': 'normal',
        overflow: 'visible'
    }
};
class SVGxml extends Wrapper_js_1.SVGWrapper {
    toSVG(parent) {
        const xml = this.adaptor.clone(this.node.getXML());
        const em = this.jax.math.metrics.em * this.jax.math.metrics.scale;
        const scale = this.fixed(1 / em);
        const { w, h, d } = this.getBBox();
        this.element = this.adaptor.append(parent, this.svg('foreignObject', {
            'data-mjx-xml': true,
            y: this.jax.fixed(-h * em) + 'px',
            width: this.jax.fixed(w * em) + 'px',
            height: this.jax.fixed((h + d) * em) + 'px',
            transform: `scale(${scale}) matrix(1 0 0 -1 0 0)`
        }, [xml]));
    }
    computeBBox(bbox, _recompute = false) {
        const { w, h, d } = this.jax.measureXMLnode(this.node.getXML());
        bbox.w = w;
        bbox.h = h;
        bbox.d = d;
    }
    getStyles() { }
    getScale() { }
    getVariant() { }
}
exports.SVGxml = SVGxml;
SVGxml.kind = MmlNode_js_1.XMLNode.prototype.kind;
SVGxml.autoStyle = false;
//# sourceMappingURL=semantics.js.map