"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.SafeHandler = exports.SafeMathDocumentMixin = void 0;
const safe_js_1 = require("./safe.js");
function SafeMathDocumentMixin(BaseDocument) {
    var _a;
    return _a = class extends BaseDocument {
            constructor(...args) {
                super(...args);
                this.safe = new this.options.SafeClass(this, this.options.safeOptions);
                const ProcessBits = this.constructor.ProcessBits;
                if (!ProcessBits.has('safe')) {
                    ProcessBits.allocate('safe');
                }
                for (const jax of this.inputJax) {
                    if (jax.name.match(/MathML/)) {
                        jax.mathml.filterAttribute = this.safe.mmlAttribute.bind(this.safe);
                        jax.mathml.filterClassList = this.safe.mmlClassList.bind(this.safe);
                    }
                    else if (jax.name.match(/TeX/)) {
                        jax.postFilters.add(this.sanitize.bind(jax), -5.5);
                    }
                }
            }
            sanitize(data) {
                data.math.root = this.parseOptions.root;
                data.document.safe.sanitize(data.math, data.document);
            }
        },
        _a.OPTIONS = Object.assign(Object.assign({}, BaseDocument.OPTIONS), { safeOptions: Object.assign({}, safe_js_1.Safe.OPTIONS), SafeClass: safe_js_1.Safe }),
        _a;
}
exports.SafeMathDocumentMixin = SafeMathDocumentMixin;
function SafeHandler(handler) {
    handler.documentClass = SafeMathDocumentMixin(handler.documentClass);
    return handler;
}
exports.SafeHandler = SafeHandler;
//# sourceMappingURL=SafeHandler.js.map