"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.asyncLoad = void 0;
const mathjax_js_1 = require("../mathjax.js");
function asyncLoad(name) {
    if (!mathjax_js_1.mathjax.asyncLoad) {
        return Promise.reject(`Can't load '${name}': No asyncLoad method specified`);
    }
    return new Promise((ok, fail) => {
        const result = mathjax_js_1.mathjax.asyncLoad(name);
        if (result instanceof Promise) {
            result.then((value) => ok(value)).catch((err) => fail(err));
        }
        else {
            ok(result);
        }
    });
}
exports.asyncLoad = asyncLoad;
//# sourceMappingURL=AsyncLoad.js.map