"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.FunctionList = void 0;
const PrioritizedList_js_1 = require("./PrioritizedList.js");
class FunctionList extends PrioritizedList_js_1.PrioritizedList {
    execute(...data) {
        for (const item of this) {
            let result = item.item(...data);
            if (result === false) {
                return false;
            }
        }
        return true;
    }
    asyncExecute(...data) {
        let i = -1;
        let items = this.items;
        return new Promise((ok, fail) => {
            (function execute() {
                while (++i < items.length) {
                    let result = items[i].item(...data);
                    if (result instanceof Promise) {
                        result.then(execute).catch(err => fail(err));
                        return;
                    }
                    if (result === false) {
                        ok(false);
                        return;
                    }
                }
                ok(true);
            })();
        });
    }
}
exports.FunctionList = FunctionList;
//# sourceMappingURL=FunctionList.js.map